SystemOrganization addCategory: #'Magritte-Model-Core'!
SystemOrganization addCategory: #'Magritte-Model-Models'!
SystemOrganization addCategory: #'Magritte-Model-Description'!
SystemOrganization addCategory: #'Magritte-Model-Accessor'!
SystemOrganization addCategory: #'Magritte-Model-Memento'!
SystemOrganization addCategory: #'Magritte-Model-Relation'!
SystemOrganization addCategory: #'Magritte-Model-Visitor'!
SystemOrganization addCategory: #'Magritte-Model-Builder'!
SystemOrganization addCategory: #'Magritte-Model-Exception'!
SystemOrganization addCategory: #'Magritte-Model-Utility'!
SystemOrganization addCategory: #'Magritte-Model-Mocks'!

SmaCCScanner subclass: #MARelationScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Relation'!

!MARelationScanner class methodsFor: 'generated-initialization' stamp: 'lr 8/13/2005 13:02'!
initializeKeywordMap
	keywordMap := Dictionary new.
	#(#(10 'AND' 4) #(10 'NOT' 1) #(10 'OR' 5) #(10 'false' 6) #(10 'nil' 2) #(10 'true' 7)) 
		do: 
			[:each | 
			(keywordMap at: each first ifAbsentPut: [Dictionary new]) at: (each at: 2)
				put: each last].
	^keywordMap! !

!MARelationScanner class methodsFor: 'generated-comments' stamp: 'lr 8/13/2005 13:02'!
scannerDefinitionComment

	"<unary>			: [a-zA-Z] [a-zA-Z0-9]* ;
<number>		: [\-]? [0-9] [0-9]* ;
<string>			: \' [^\']* \' (\' [^\']* \')* ;
<keyword>		: <unary> \: ;
<binary>		: [\~\-\!!\@\%\&\*\+\=\\\|\?\/\>\<\,] [\~\!!\@\%\&\*\+\=\\\|\?\/\>\<\,]? ;
<whitespace>		: \s+ ;
<comment>		: \"" [^\""]* \"" ;"! !

!MARelationScanner methodsFor: 'generated-tokens' stamp: 'lr 8/13/2005 13:02'!
emptySymbolTokenId
	^30! !

!MARelationScanner methodsFor: 'generated-tokens' stamp: 'lr 8/13/2005 13:02'!
errorTokenId
	^31! !

!MARelationScanner methodsFor: 'generated-scanner' stamp: 'lr 8/13/2005 13:02'!
scan1
	
	[
	[self step.
	currentCharacter ~~ $'] whileTrue.
	self recordMatch: #(12).
	self step.
	currentCharacter == $'] 
			whileTrue: [].
	^self reportLastMatch! !

!MARelationScanner methodsFor: 'generated-scanner' stamp: 'lr 8/13/2005 13:02'!
scanForToken
	self step.
	((currentCharacter between: $A and: $Z) 
		or: [currentCharacter between: $a and: $z]) 
			ifTrue: 
				[
				[self recordMatch: #(10).
				self step.
				currentCharacter isDigit or: 
						[(currentCharacter between: $A and: $Z) 
							or: [currentCharacter between: $a and: $z]]] 
						whileTrue.
				currentCharacter == $: ifTrue: [^self recordAndReportMatch: #(13)].
				^self reportLastMatch].
	(currentCharacter == $!! or: 
			[(currentCharacter between: $% and: $&) or: 
					[(currentCharacter between: $* and: $,) or: 
							[currentCharacter == $/ or: 
									[(currentCharacter between: $< and: $@) or: 
											[currentCharacter == $\ 
												or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]) 
		ifTrue: 
			[self recordMatch: #(14).
			self step.
			(currentCharacter == $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $,) or: 
									[currentCharacter == $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter == $\ 
														or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]) 
				ifTrue: [^self recordAndReportMatch: #(14)].
			^self reportLastMatch].
	currentCharacter isDigit 
		ifTrue: 
			[
			[self recordMatch: #(11).
			self step.
			currentCharacter isDigit] 
					whileTrue.
			^self reportLastMatch].
	(currentCharacter isSeparator or: [currentCharacter == $]) 
		ifTrue: 
			[
			[self recordMatch: #whitespace.
			self step.
			currentCharacter isSeparator or: [currentCharacter == $]] 
					whileTrue.
			^self reportLastMatch].
	currentCharacter == $" 
		ifTrue: 
			[
			[self step.
			currentCharacter ~~ $"] whileTrue.
			^self recordAndReportMatch: #comment].
	currentCharacter == $' ifTrue: [^self scan1].
	currentCharacter == $( ifTrue: [^self recordAndReportMatch: #(8)].
	currentCharacter == $) ifTrue: [^self recordAndReportMatch: #(9)].
	currentCharacter == $- 
		ifTrue: 
			[self recordMatch: #(3 14).
			self step.
			(currentCharacter == $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $,) or: 
									[currentCharacter == $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter == $\ 
														or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]) 
				ifTrue: [^self recordAndReportMatch: #(14)].
			currentCharacter isDigit 
				ifTrue: 
					[
					[self recordMatch: #(11).
					self step.
					currentCharacter isDigit] 
							whileTrue.
					^self reportLastMatch].
			^self reportLastMatch].
	^self reportLastMatch! !

Error subclass: #MAError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Exception'!

MAError subclass: #MAReadError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Exception'!

MAError subclass: #MAValidationError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Exception'!

MAValidationError subclass: #MAConditionError
	instanceVariableNames: 'explanation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Exception'!

!MAConditionError class methodsFor: 'instance creation' stamp: 'lr 9/25/2005 15:16'!
on: aDescription explanation: aString
	^ self new 
		setDescription: aDescription;
		setExplanation: aString;
		signal.! !

!MAConditionError methodsFor: 'accessing' stamp: 'lr 9/25/2005 15:15'!
explanation
	^ explanation! !

!MAConditionError methodsFor: 'initialization' stamp: 'lr 9/25/2005 15:17'!
setExplanation: aString
	explanation := aString! !

MAValidationError subclass: #MAConflictError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Exception'!

!MAConflictError methodsFor: 'accessing' stamp: 'lr 11/7/2005 09:28'!
explanation
	^ 'Input is conflicting with concurrent modification'! !

MAValidationError subclass: #MAKindError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Exception'!

!MAKindError methodsFor: 'accessing' stamp: 'lr 11/7/2005 09:28'!
explanation
	^ 'Invalid input given'! !

MAValidationError subclass: #MAMultipleErrors
	instanceVariableNames: 'collection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Exception'!

!MAMultipleErrors class methodsFor: 'instance-creation' stamp: 'lr 9/20/2005 21:36'!
on: aDescription errors: aCollection
	^ self new
		setDescription: aDescription;
		setCollection: aCollection;
		signal.! !

!MAMultipleErrors methodsFor: 'accessing' stamp: 'lr 9/18/2005 18:19'!
collection
	^ collection! !

!MAMultipleErrors methodsFor: 'accessing' stamp: 'lr 11/7/2005 09:46'!
explanation
	^ 'Multiple errors'! !

!MAMultipleErrors methodsFor: 'printing' stamp: 'lr 11/7/2005 09:52'!
printOn: aStream
	self collection 
		do: [ :each | aStream print: each ]
		separatedBy: [ aStream nextPut: Character cr ].! !

!MAMultipleErrors methodsFor: 'initialization' stamp: 'lr 9/18/2005 18:19'!
setCollection: aCollection
	collection := aCollection! !

MAValidationError subclass: #MARangeError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Exception'!

!MARangeError methodsFor: 'accessing' stamp: 'lr 10/19/2005 20:13'!
explanation
	| min max |
	min := self tag toString: self tag min.
	max := self tag toString: self tag max.
	^ String streamContents: [ :stream |
		stream nextPutAll: 'Input must be '.
		self tag max isNil
			ifTrue: [ stream nextPutAll: 'above '; nextPutAll: min ]
			ifFalse: [
				self tag min isNil
					ifTrue: [ stream nextPutAll: 'below '; nextPutAll: max ]
					ifFalse: [ stream nextPutAll: 'between '; nextPutAll: min; nextPutAll: ' and '; nextPutAll: max ] ] ].! !

MAValidationError subclass: #MARequiredError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Exception'!

!MARequiredError methodsFor: 'accessing' stamp: 'lr 9/23/2005 12:26'!
explanation
	^ 'Input is required but no input given'! !

!MAValidationError class methodsFor: 'instance creation' stamp: 'lr 9/23/2005 12:49'!
on: aDescription
	^ self new 
		setDescription: aDescription;
		signal.! !

!MAValidationError methodsFor: 'accessing' stamp: 'lr 9/23/2005 12:24'!
explanation
	self subclassResponsibility.! !

!MAValidationError methodsFor: 'testing' stamp: 'lr 11/7/2005 09:48'!
hasLabel
	^ self tag hasLabel.! !

!MAValidationError methodsFor: 'accessing' stamp: 'lr 11/7/2005 09:45'!
label
	^ self tag label ifNil: [ self tag asString ].! !

!MAValidationError methodsFor: 'printing' stamp: 'lr 11/7/2005 09:50'!
printOn: aStream
	aStream nextPutAll: self label; nextPutAll: ': '; nextPutAll: self explanation.! !

!MAValidationError methodsFor: 'initialization' stamp: 'lr 9/23/2005 12:26'!
setDescription: aDescription
	self tag: aDescription.! !

MAError subclass: #MAWriteError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Exception'!

Object subclass: #MAAddressModel
	instanceVariableNames: 'street plz place canton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Mocks'!

!MAAddressModel class methodsFor: 'accessing-description' stamp: 'lr 10/19/2005 21:29'!
descriptionCity
	^ (MASingleOptionDescription auto: 'canton' label: 'Canton' priority: 40)
		options: #( 'Zurich' 'Bern' 'Luzern' 'Uri' 'Schwyz' 'Unterwalden' 'Glarus' 'Zug' 'Freiburg' 'Solothurn' 'Basel' 'Schaffhausen' 'Appenzell' 'St. Gallen' 'Graubunden' 'Aargau' 'Thurgau' 'Ticino' 'Vaud' 'Valais' 'Neuchatel' 'Geneve' 'Jura' );
		reference: MAStringDescription new;
		beSorted;
		yourself.! !

!MAAddressModel class methodsFor: 'accessing-description' stamp: 'lr 10/19/2005 19:58'!
descriptionPlace
	^ MAStringDescription auto: 'place' label: 'Place' priority: 30.! !

!MAAddressModel class methodsFor: 'accessing-description' stamp: 'lr 10/19/2005 21:31'!
descriptionPlz
	^ (MANumberDescription auto: 'plz' label: 'PLZ' priority: 20)
		min: 1000 max: 9999;
		yourself.! !

!MAAddressModel class methodsFor: 'accessing-description' stamp: 'lr 10/19/2005 19:57'!
descriptionStreet
	^ MAStringDescription auto: 'street' label: 'Street' priority: 10.! !

!MAAddressModel methodsFor: 'accessing' stamp: 'lr 10/27/2005 17:38'!
canton
	^ canton! !

!MAAddressModel methodsFor: 'accessing' stamp: 'lr 10/27/2005 17:39'!
canton: anObject
	canton := anObject! !

!MAAddressModel methodsFor: 'accessing' stamp: 'lr 10/27/2005 17:38'!
place
	^ place! !

!MAAddressModel methodsFor: 'accessing' stamp: 'lr 10/27/2005 17:39'!
place: anObject
	place := anObject! !

!MAAddressModel methodsFor: 'accessing' stamp: 'lr 10/27/2005 17:38'!
plz
	^ plz! !

!MAAddressModel methodsFor: 'accessing' stamp: 'lr 10/27/2005 17:39'!
plz: anObject
	plz := anObject! !

!MAAddressModel methodsFor: 'accessing' stamp: 'lr 10/27/2005 17:38'!
street
	^ street! !

!MAAddressModel methodsFor: 'accessing' stamp: 'lr 10/27/2005 17:39'!
street: anObject
	street := anObject! !

!MAAddressModel methodsFor: 'comparing' stamp: 'lr 10/19/2005 21:21'!
= anObject
	^ self species = anObject species
		and: [ self street = anObject street
		and: [ self plz = anObject plz
		and: [ self place = anObject place
		and: [ self canton = anObject canton ] ] ] ].! !

Object subclass: #MABlockToRelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Relation'!

!MABlockToRelation class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
do: aBlock
	^ aBlock value: self new.! !

!MABlockToRelation methodsFor: 'testing-collection' stamp: 'lr 5/8/2005 20:29'!
beginsWith: anObject
	^ MASelectorRelation selector: #beginsWith: with: anObject.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 5/8/2005 20:29'!
between: aMinimum and: aMaximum 
	^ MASelectorRelation selector: #between:and: with: aMinimum with: aMaximum.! !

!MABlockToRelation methodsFor: 'private' stamp: 'lr 10/28/2005 16:48'!
doesNotUnderstand: aMessage
	^ MASelectorRelation selector: aMessage selector arguments: aMessage arguments.! !

!MABlockToRelation methodsFor: 'testing-collection' stamp: 'lr 5/8/2005 20:29'!
endsWith: anObject
	^ MASelectorRelation selector: #endsWith: with: anObject.! !

!MABlockToRelation methodsFor: 'testing-objects' stamp: 'lr 5/9/2005 10:07'!
hash
	^ self shouldNotImplement.! !

!MABlockToRelation methodsFor: 'testing-collection' stamp: 'lr 5/8/2005 20:29'!
includes: anObject
	^ MASelectorRelation selector: #includes: with: anObject.! !

!MABlockToRelation methodsFor: 'testing-collection' stamp: 'lr 5/8/2005 20:29'!
isEmpty
	^ MASelectorRelation selector: #isEmpty.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 5/8/2005 20:29'!
isEven
	^ MASelectorRelation selector: #even.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 5/8/2005 20:29'!
isFloat
	^ MASelectorRelation selector: #isFloat.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 5/8/2005 20:29'!
isInteger
	^ MASelectorRelation selector: #isInteger.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 5/8/2005 20:29'!
isNegative
	^ MASelectorRelation selector: #negative.! !

!MABlockToRelation methodsFor: 'testing-objects' stamp: 'lr 10/28/2005 16:41'!
isNil
	^ MASelectorRelation selector: #isNil.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 5/8/2005 20:29'!
isOdd
	^ MASelectorRelation selector: #odd.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 5/8/2005 20:29'!
isPositive
	^ MASelectorRelation selector: #positive.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 5/8/2005 20:29'!
isZero
	^ MASelectorRelation selector: #isZero.! !

!MABlockToRelation methodsFor: 'testing-collection' stamp: 'lr 11/8/2005 14:57'!
matches: anObject
	^ MASelectorRelation selector: #matches: with: anObject.! !

!MABlockToRelation methodsFor: 'testing-collection' stamp: 'lr 5/8/2005 20:29'!
notEmpty
	^ MASelectorRelation selector: #notEmpty.! !

!MABlockToRelation methodsFor: 'testing-objects' stamp: 'lr 5/8/2005 20:29'!
notNil
	^ MASelectorRelation selector: #notNil.! !

!MABlockToRelation methodsFor: 'testing-operators' stamp: 'lr 5/8/2005 20:29'!
< anObject
	^ MASelectorRelation selector: #< with: anObject.! !

!MABlockToRelation methodsFor: 'testing-operators' stamp: 'lr 5/8/2005 20:29'!
<= anObject
	^ MASelectorRelation selector: #<= with: anObject.! !

!MABlockToRelation methodsFor: 'testing-operators' stamp: 'lr 5/8/2005 20:29'!
= anObject
	^ MASelectorRelation selector: #= with: anObject.! !

!MABlockToRelation methodsFor: 'testing-operators' stamp: 'lr 5/8/2005 20:29'!
> anObject
	^ MASelectorRelation selector: #> with: anObject.! !

!MABlockToRelation methodsFor: 'testing-operators' stamp: 'lr 5/8/2005 20:29'!
>= anObject
	^ MASelectorRelation selector: #>= with: anObject.! !

!MABlockToRelation methodsFor: 'testing-operators' stamp: 'lr 5/8/2005 20:29'!
~= anObject
	^ MASelectorRelation selector: #~= with: anObject.! !

Object subclass: #MABuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Builder'!

MABuilder class
	instanceVariableNames: 'default'!

!MABuilder class methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:33'!
default
	default isNil
		ifTrue: [ default := self new ].
	^ default.! !

!MABuilder methodsFor: 'actions' stamp: 'lr 9/22/2005 00:35'!
build: anObject
	| description |
	^ anObject defaultContainer in: [ :container |
		anObject class allSelectors do: [ :each |
			(self isDescriptionSelector: each) ifTrue: [
				description := anObject perform: each.
				description isDescription
					ifTrue: [ container add: description ] ] ].
		container ].! !

!MABuilder methodsFor: 'testing' stamp: 'lr 5/8/2005 20:29'!
isDescriptionSelector: aSelector
	^ aSelector notNil
		and: [ aSelector isUnary ]
		and: [ aSelector ~= #description ] 
		and: [ aSelector beginsWith: #description ].! !

MABuilder subclass: #MACachedBuilder
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Builder'!

!MACachedBuilder methodsFor: 'actions' stamp: 'lr 5/8/2005 20:29'!
build: anObject
	^ self cache
		at: anObject
		ifAbsentPut: [ super build: anObject ].! !

!MACachedBuilder methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
cache
	^ cache! !

!MACachedBuilder methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
cache: aDictionary
	cache := aDictionary! !

!MACachedBuilder methodsFor: 'actions' stamp: 'lr 5/8/2005 20:29'!
flush
	self cache: IdentityDictionary new.! !

!MACachedBuilder methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:29'!
initialize
	super initialize.
	self flush; register.! !

!MACachedBuilder methodsFor: 'events' stamp: 'lr 5/8/2005 20:29'!
modified: anEvent
	(self isDescriptionSelector: anEvent itemSelector) 
		ifTrue: [ self flush ].! !

!MACachedBuilder methodsFor: 'events' stamp: 'lr 5/8/2005 20:29'!
register
	SystemChangeNotifier uniqueInstance
		noMoreNotificationsFor: self;
		notify: self ofSystemChangesOfItem: #method change: #Added using: #modified:;
		notify: self ofSystemChangesOfItem: #method change: #Modified using: #modified:;
		notify: self ofSystemChangesOfItem: #method change: #Removed using: #modified:.! !

Object subclass: #MACompatibility
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Core'!

!MACompatibility class methodsFor: 'user-interface' stamp: 'lr 11/7/2005 18:03'!
choose: aString from: aCollection
	"Display aString to the user and let him choose any of the items in aCollection."

	| index |
	index := PopUpMenu 
		withCaption: aString 
		chooseFrom: (aCollection collect: [ :each | each asString ]).
	^ index isZero 
		ifFalse: [ aCollection at: index ].! !

!MACompatibility class methodsFor: 'environment' stamp: 'lr 11/7/2005 18:03'!
classNamed: aString
	"Return the class named aString, nil if the class can't be found."

	^ Smalltalk classNamed: aString.! !

!MACompatibility class methodsFor: 'user-interface' stamp: 'lr 11/7/2005 18:03'!
confirm: aString
	"Display aString to the user and let him confirm."

	^ PopUpMenu confirm: aString.! !

!MACompatibility class methodsFor: 'user-interface' stamp: 'lr 11/7/2005 18:03'!
inform: aString
	"Display aString to the user."

	^ PopUpMenu inform: aString.! !

!MACompatibility class methodsFor: 'user-interface' stamp: 'lr 11/7/2005 18:03'!
openWorkspace: aContentsString titled: aTitleString
	"Open a new wokspace with the contents aContentsString and the title aTitleString."

	Workspace new 
		contents: aContentsString; 
		openLabel: aTitleString.! !

!MACompatibility class methodsFor: 'environment' stamp: 'lr 11/7/2005 18:03'!
referenceStream: aReadWriteStream 
	"Return a stream instance to operate on aReadWriteStream being able to serialize and deserialize objects by sending #nextPut: and #next. Squeak: The implementation of ReferenceStream doesn't work well together with the default WriteStream implementaiton, therefor we have to change it on the fly."

	^ ReferenceStream on: (aReadWriteStream class = WriteStream
		ifTrue: [ RWBinaryOrTextStream on: aReadWriteStream contents ]
		ifFalse: [ aReadWriteStream ]).! !

!MACompatibility class methodsFor: 'user-interface' stamp: 'lr 11/7/2005 18:03'!
request: aString default: anObject
	"Display aString and requests an input from the user, whereas anObject is the default value."

	^ FillInTheBlankMorph 
		request: aString 
		initialAnswer: anObject
		centerAt: ActiveHand cursorPoint
		inWorld: ActiveWorld
		onCancelReturn: nil.! !

!MACompatibility class methodsFor: 'environment' stamp: 'lr 11/7/2005 18:02'!
uuid
	"Answer a random object that is enormous likely to be unique over space and time."

	^ UUID new.! !

Object subclass: #MADistribution
	instanceVariableNames: 'zip username password preamble postscript prepared'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Core'!

!MADistribution class methodsFor: 'accessing' stamp: 'lr 10/31/2005 13:59'!
license
	"Return a string with the license of the package. This string shall not be removed or altered in any case."

	^ 'The MIT License
	
Copyright (c) 2003-2005 Lukas Renggli, renggli@iam.unibe.ch
Copyright (c) 2003-2005 Software Composition Group, University of Bern

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.'! !

!MADistribution class methodsFor: 'accessing' stamp: 'lr 10/31/2005 13:59'!
package
	"The SqueakMap package name."

	^ 'Magritte'! !

!MADistribution class methodsFor: 'accessing' stamp: 'lr 10/31/2005 13:59'!
packages
	"Return a collection of package names that should be distributed and eventually installed."

	^ #( ( 'DynamicBindings' 'PasteUpMorph confirm: ''Would you like to install Seaside?''' )
		 ( 'KomServices' 'Smalltalk includesKey: #DynamicBindings' )
		 ( 'KomHttpServer' 'Smalltalk includesKey: #TcpService' )
		 ( 'Seaside2' 'Smalltalk includesKey: #HttpService' )
		 ( 'Scriptaculous' 'Smalltalk includesKey: #WAComponent' )

		 ( 'Magritte-Model' )
		 ( 'Magritte-Tests' 'Smalltalk includesKey: #TestCase' )
		 ( 'Magritte-Morph' 'Smalltalk includesKey: #Morph' )
		 ( 'Magritte-Seaside' 'Smalltalk includesKey: #WAComponent' ) ).! !

!MADistribution class methodsFor: 'execution' stamp: 'lr 11/7/2005 11:11'!
postload
	"This method will be automatically called after successful loading of the distribution."

	MACompatibility openWorkspace: self license titled: 'License'.
	self registerRepository: 'http://mc.lukas-renggli.ch/magritte'.! !

!MADistribution class methodsFor: 'accessing' stamp: 'lr 10/31/2005 13:57'!
postscript
	^ self name , ' postload.'! !

!MADistribution class methodsFor: 'accessing' stamp: 'lr 10/31/2005 13:56'!
preamble
	^ String new.! !

!MADistribution class methodsFor: 'private' stamp: 'lr 11/7/2005 11:11'!
registerRepository: aString
	| repositoryGroup httpRespository |
	repositoryGroup := Smalltalk classNamed: #MCRepositoryGroup.
	httpRespository := Smalltalk classNamed: #MCHttpRepository.
	(repositoryGroup notNil and: [ httpRespository notNil ]) ifTrue: [
		repositoryGroup default 
			addRepository: (httpRespository
				location: 'http://mc.lukas-renggli.ch/magritte'
				user: String new password: String new) ].! !

!MADistribution class methodsFor: 'accessing' stamp: 'lr 11/7/2005 12:00'!
version
	"The first item is the product name, which should only contain lowercase letters. Then the version numbers are following, that are made up of three numbers. An optimal suffix alpha, beta, pre or rc follows. External packages or extensions might want to call this method to check the version required to run."

	^ #( magritte 1 0 3 alpha ).! !

!MADistribution class methodsFor: 'accessing' stamp: 'lr 10/31/2005 14:28'!
versionNote
	"This is a string to be used as release-note in SqueakMap."

	^ String new.! !

!MADistribution methodsFor: 'adding' stamp: 'lr 10/18/2005 20:37'!
addPackage: aPackage
	(self preparedPackages includes: aPackage) 
		ifTrue: [ ^ self ].
	self 
		addPackage: aPackage
		workingCopy: (MCWorkingCopy registry 
			at: aPackage).! !

!MADistribution methodsFor: 'adding' stamp: 'lr 10/31/2005 13:31'!
addPackage: aPackage version: aVersion
	| condition |
	self zip 
		addString: (ByteArray streamContents: [ :stream |
			aVersion fileOutOn: stream ])
		as: aVersion fileName.
	self addPreamble: (String streamContents: [ :stream |
		condition := self class packages
			detect: [ :each | aPackage name = each first ]
			ifNone: [ Array with: aPackage name ].
		condition size > 1 
			ifFalse: [ condition := condition copyWith: 'true' ].
		stream
			nextPut: $(; nextPutAll: condition second; nextPutAll: ') ifTrue: [ ';
			nextPutAll: 'self fileInMonticelloZipVersionNamed: '; 
			print: aVersion fileName; nextPutAll: ' ].' ]).
	self preparedPackages add: aPackage.! !

!MADistribution methodsFor: 'adding' stamp: 'lr 10/31/2005 14:31'!
addPackage: aPackage workingCopy: aWorkingCopy
	aWorkingCopy modified
		ifTrue: [ self error: aPackage name , ' needs to be saved first.' ].
	aWorkingCopy requiredPackages
		do: [ :each | self addPackage: each ].
	self 
		addPackage: aPackage
		version: (MCVersion
			package: aPackage
			info: (aWorkingCopy ancestry
				infoWithName: aWorkingCopy ancestors first name
				message: self versionString)
			snapshot: aPackage snapshot).! !

!MADistribution methodsFor: 'adding' stamp: 'lr 10/17/2005 19:20'!
addPostscript: aString
	postscript := self postscriptString copyWithAll: aString , String cr.! !

!MADistribution methodsFor: 'adding' stamp: 'lr 10/17/2005 19:20'!
addPreamble: aString
	preamble := self preambleString copyWithAll: aString , String cr.! !

!MADistribution methodsFor: 'accessing-dynamic' stamp: 'lr 10/17/2005 18:06'!
basePackages
	^ self class packages collect: [ :each | MCPackage named: each first ].! !

!MADistribution methodsFor: 'private' stamp: 'lr 10/18/2005 20:45'!
checkResult: aString
	| result |
	result := #( 'HTTP/1.1 201 ' 'HTTP/1.1 200 ' 'HTTP/1.0 201 ' 'HTTP/1.0 200 ')
		anySatisfy: [ :each | aString beginsWith: each ].
	result ifFalse: [ self error: aString ].! !

!MADistribution methodsFor: 'building' stamp: 'lr 10/31/2005 13:35'!
dump
	"Dump the sar-archive to the file-system."

	self zip writeToFileNamed: self filename.! !

!MADistribution methodsFor: 'accessing' stamp: 'lr 10/18/2005 20:46'!
filename
	^ self versionString , '.sar'.! !

!MADistribution methodsFor: 'initialization' stamp: 'lr 10/31/2005 14:49'!
initialize
	super initialize.
	self basePackages 
		do: [ :each | self addPackage: each ]
		displayingProgress: self versionString.
	(self zip addString: self preambleString as: 'install/preamble')
		desiredCompressionLevel: 9.
	(self zip addString: self postscriptString as: 'install/postscript')
		desiredCompressionLevel: 9.! !

!MADistribution methodsFor: 'accessing' stamp: 'lr 10/18/2005 20:50'!
password
	^ password ifNil: [ password := MACompatibility request: 'SqueakMap Password:' default: '' ].! !

!MADistribution methodsFor: 'accessing-dynamic' stamp: 'lr 10/17/2005 18:59'!
postscriptString
	^ postscript ifNil: [ postscript := self class postscript ].! !

!MADistribution methodsFor: 'accessing-dynamic' stamp: 'lr 10/17/2005 18:59'!
preambleString
	^ preamble ifNil: [ preamble := self class preamble ].! !

!MADistribution methodsFor: 'accessing-dynamic' stamp: 'lr 10/17/2005 17:17'!
preparedPackages
	^ prepared ifNil: [ prepared := Set new ].! !

!MADistribution methodsFor: 'building' stamp: 'lr 11/7/2005 18:49'!
publish
	"Publish the receiver as a new release on SqueakMap."

	| result |
	result := HTTPSocket
		httpPost: self squeakMapUrl , 'packagebyname/' , self class package , '/newrelease'
		args: (Array
			with: 'version' -> (Array with: self versionNumber)
			with: 'note' -> (Array with: self versionNote)
			with: 'downloadURL' -> (Array with: self upload)
			with: 'name' -> (Array with: self versionName)
			with: 'summary' -> (Array with: self versionString))
		user: self username 
		passwd: self password.
	result contents = self versionNumber
		ifFalse: [ self error: result contents ].! !

!MADistribution methodsFor: 'private' stamp: 'lr 10/18/2005 21:02'!
squeakMapUrl 
	^ 'http://map1.squeakfoundation.org/sm/'! !

!MADistribution methodsFor: 'private' stamp: 'lr 10/18/2005 21:03'!
upload
	| result stream |
	result := HTTPSocket
		httpPut: (ByteArray streamContents: [ :s | self zip writeTo: s ])
		to: self squeakMapUrl , 'upload/' , self filename
		user: self username passwd: self password.
	self checkResult: result.
	stream := result readStream.
	stream upToAll: 'http://'.
	^ 'http://' , stream upToEnd.! !

!MADistribution methodsFor: 'accessing' stamp: 'lr 10/18/2005 20:49'!
username
	^ username ifNil: [ username := MACompatibility request: 'SqueakMap Username:' default: 'lr' ].! !

!MADistribution methodsFor: 'accessing-dynamic' stamp: 'lr 10/31/2005 14:38'!
versionName
	^ self class version first asString.! !

!MADistribution methodsFor: 'accessing-dynamic' stamp: 'lr 10/31/2005 14:39'!
versionNote
	^ self class versionNote.! !

!MADistribution methodsFor: 'accessing-dynamic' stamp: 'lr 10/31/2005 14:28'!
versionNumber
	^ String streamContents: [ :output |
		self class version allButFirst readStream in: [ :input |
			[ input atEnd or: [ input peek isString ] ] 
				whileFalse: [ output print: input next; nextPut: $. ].
			output skip: -1. 
			input atEnd 
				ifFalse: [ output nextPut: $-; nextPutAll: input next ] ] ].! !

!MADistribution methodsFor: 'accessing-dynamic' stamp: 'lr 10/31/2005 14:37'!
versionString
	^ String streamContents: [ :output |
		output nextPutAll: self versionName; nextPut: $-; nextPutAll: self versionNumber ].! !

!MADistribution methodsFor: 'accessing' stamp: 'lr 10/18/2005 20:52'!
zip
	^ zip ifNil: [ zip := ZipArchive new ].! !

Object subclass: #MAFileModel
	instanceVariableNames: 'contents mimetype filename'
	classVariableNames: 'MimeTypes'
	poolDictionaries: ''
	category: 'Magritte-Model-Models'!

!MAFileModel class methodsFor: 'accessing-defaults' stamp: 'lr 8/10/2005 19:33'!
defaultMimeType
	^ 'application/octet-stream'.! !

!MAFileModel class methodsFor: 'accessing-defaults' stamp: 'lr 8/10/2005 19:10'!
defaultMimeTypes
	^ #( 'ai' 'application/postscript' 'aif' 'audio/x-aiff' 'aifc' 'audio/x-aiff' 'aiff' 'audio/x-aiff' 'asc' 'text/plain' 'au' 'audio/basic' 'avi' 'video/x-msvideo' 'bcpio' 'application/x-bcpio' 'bin' 'application/octet-stream' 'c' 'text/plain' 'cc' 'text/plain' 'ccad' 'application/clariscad' 'cdf' 'application/x-netcdf' 'class' 'application/octet-stream' 'cpio' 'application/x-cpio' 'cpt' 'application/mac-compactpro' 'csh' 'application/x-csh' 'css' 'text/css' 'dcr' 'application/x-director' 'dir' 'application/x-director' 'dms' 'application/octet-stream' 'doc' 'application/msword' 'drw' 'application/drafting' 'dvi' 'application/x-dvi' 'dwg' 'application/acad' 'dxf' 'application/dxf' 'dxr' 'application/x-director' 'eps' 'application/postscript' 'etx' 'text/x-setext' 'exe' 'application/octet-stream' 'ez' 'application/andrew-inset' 'f' 'text/plain' 'f90' 'text/plain' 'fli' 'video/x-fli' 'gif' 'image/gif' 'gtar' 'application/x-gtar' 'gz' 'application/x-gzip' 'h' 'text/plain' 'hdf' 'application/x-hdf' 'hh' 'text/plain' 'hqx' 'application/mac-binhex40' 'htm' 'text/html' 'html' 'text/html' 'ice' 'x-conference/x-cooltalk' 'ief' 'image/ief' 'iges' 'model/iges' 'igs' 'model/iges' 'ips' 'application/x-ipscript' 'ipx' 'application/x-ipix' 'jpe' 'image/jpeg' 'jpeg' 'image/jpeg' 'jpg' 'image/jpeg' 'js' 'application/x-javascript' 'kar' 'audio/midi' 'latex' 'application/x-latex' 'lha' 'application/octet-stream' 'lsp' 'application/x-lisp' 'lzh' 'application/octet-stream' 'm' 'text/plain' 'man' 'application/x-troff-man' 'me' 'application/x-troff-me' 'mesh' 'model/mesh' 'mid' 'audio/midi' 'midi' 'audio/midi' 'mif' 'application/vnd.mif' 'mime' 'www/mime' 'mov' 'video/quicktime' 'movie' 'video/x-sgi-movie' 'mp2' 'audio/mpeg' 'mp3' 'audio/mpeg' 'mpe' 'video/mpeg' 'mpeg' 'video/mpeg' 'mpg' 'video/mpeg' 'mpga' 'audio/mpeg' 'ms' 'application/x-troff-ms' 'msh' 'model/mesh' 'nc' 'application/x-netcdf' 'oda' 'application/oda' 'pbm' 'image/x-portable-bitmap' 'pdb' 'chemical/x-pdb' 'pdf' 'application/pdf' 'pgm' 'image/x-portable-graymap' 'pgn' 'application/x-chess-pgn' 'png' 'image/png' 'pnm' 'image/x-portable-anymap' 'pot' 'application/mspowerpoint' 'ppm' 'image/x-portable-pixmap' 'pps' 'application/mspowerpoint' 'ppt' 'application/mspowerpoint' 'ppz' 'application/mspowerpoint' 'pre' 'application/x-freelance' 'prt' 'application/pro_eng' 'ps' 'application/postscript' 'qt' 'video/quicktime' 'ra' 'audio/x-realaudio' 'ram' 'audio/x-pn-realaudio' 'ras' 'image/cmu-raster' 'rgb' 'image/x-rgb' 'rm' 'audio/x-pn-realaudio' 'roff' 'application/x-troff' 'rpm' 'audio/x-pn-realaudio-plugin' 'rtf' 'text/rtf' 'rtx' 'text/richtext' 'scm' 'application/x-lotusscreencam' 'set' 'application/set' 'sgm' 'text/sgml' 'sgml' 'text/sgml' 'sh' 'application/x-sh' 'shar' 'application/x-shar' 'silo' 'model/mesh' 'sit' 'application/x-stuffit' 'skd' 'application/x-koan' 'skm' 'application/x-koan' 'skp' 'application/x-koan' 'skt' 'application/x-koan' 'smi' 'application/smil' 'smil' 'application/smil' 'snd' 'audio/basic' 'sol' 'application/solids' 'spl' 'application/x-futuresplash' 'src' 'application/x-wais-source' 'step' 'application/STEP' 'stl' 'application/SLA' 'stp' 'application/STEP' 'sv4cpio' 'application/x-sv4cpio' 'sv4crc' 'application/x-sv4crc' 'swf' 'application/x-shockwave-flash' 't' 'application/x-troff' 'tar' 'application/x-tar' 'tcl' 'application/x-tcl' 'tex' 'application/x-tex' 'texi' 'application/x-texinfo' 'texinfo' 'application/x-texinfo' 'tif' 'image/tiff' 'tiff' 'image/tiff' 'tr' 'application/x-troff' 'tsi' 'audio/TSP-audio' 'tsp' 'application/dsptype' 'tsv' 'text/tab-separated-values' 'txt' 'text/plain' 'unv' 'application/i-deas' 'ustar' 'application/x-ustar' 'vcd' 'application/x-cdlink' 'vda' 'application/vda' 'viv' 'video/vnd.vivo' 'vivo' 'video/vnd.vivo' 'vrml' 'model/vrml' 'wav' 'audio/x-wav' 'wrl' 'model/vrml' 'xbm' 'image/x-xbitmap' 'xlc' 'application/vnd.ms-excel' 'xll' 'application/vnd.ms-excel' 'xlm' 'application/vnd.ms-excel' 'xls' 'application/vnd.ms-excel' 'xlw' 'application/vnd.ms-excel' 'xml' 'text/xml' 'xpm' 'image/x-xpixmap' 'xwd' 'image/x-xwindowdump' 'xyz' 'chemical/x-pdb' 'zip' 'application/zip' ).! !

!MAFileModel class methodsFor: 'class initialization' stamp: 'lr 8/10/2005 19:33'!
initialize
	MimeTypes := Dictionary new.
	1 to: self defaultMimeTypes size by: 2 do: [ :index |
		MimeTypes
			at: (self defaultMimeTypes at: index)
			put: (self defaultMimeTypes at: index + 1) ].! !

!MAFileModel class methodsFor: 'accessing' stamp: 'lr 8/10/2005 19:34'!
mimetypeFor: aString
	^ self mimetypes at: aString ifAbsent: [ self defaultMimeType ].! !

!MAFileModel class methodsFor: 'accessing' stamp: 'lr 8/10/2005 19:34'!
mimetypes
	^ MimeTypes.! !

!MAFileModel methodsFor: 'accessing' stamp: 'lr 8/10/2005 19:37'!
contents
	^ contents ifNil: [ ByteArray new ].! !

!MAFileModel methodsFor: 'accessing' stamp: 'lr 8/10/2005 18:13'!
contents: aByteArray
	contents := aByteArray! !

!MAFileModel methodsFor: 'convenience' stamp: 'lr 8/10/2005 19:40'!
extension
	^ self filename copyAfterLast: $..! !

!MAFileModel methodsFor: 'accessing' stamp: 'lr 8/10/2005 19:37'!
filename
	^ filename ifNil: [ String new ].! !

!MAFileModel methodsFor: 'accessing' stamp: 'lr 8/10/2005 18:15'!
filename: aString
	filename := aString! !

!MAFileModel methodsFor: 'comparing' stamp: 'lr 8/10/2005 19:54'!
hash
	^ (self contents hash bitXor: self filename hash) bitXor: self mimetype hash.! !

!MAFileModel methodsFor: 'testing' stamp: 'lr 8/10/2005 20:06'!
isApplication
	"Return true if the mimetype of the receiver is application-data. This message will match types like: application/postscript, application/zip, application/pdf, etc."

	^ self maintype = 'application'.! !

!MAFileModel methodsFor: 'testing' stamp: 'lr 9/9/2005 11:12'!
isAudio
	"Return true if the mimetype of the receiver is audio-data. This message will match types like: audio/basic, audio/tone, audio/mpeg, etc."

	^ self maintype = 'audio'.! !

!MAFileModel methodsFor: 'testing' stamp: 'lr 8/12/2005 08:53'!
isEmpty
	^ contents isNil
		or: [ filename isNil ]
		or: [ mimetype isNil ].! !

!MAFileModel methodsFor: 'testing' stamp: 'lr 8/10/2005 20:07'!
isImage
	"Return true if the mimetype of the receiver is image-data. This message will match types like: image/jpeg, image/gif, image/png, image/tiff, etc."

	^ self maintype = 'image'.! !

!MAFileModel methodsFor: 'testing' stamp: 'lr 8/10/2005 20:07'!
isText
	"Return true if the mimetype of the receiver is text-data. This message will match types like: text/plain, text/html, text/sgml, text/css, text/xml, text/richtext, etc."

	^ self maintype = 'text'.! !

!MAFileModel methodsFor: 'testing' stamp: 'lr 8/10/2005 20:07'!
isVideo
	"Return true if the mimetype of the receiver is video-data. This message will match types like: video/mpeg, video/quicktime, etc."

	^ self maintype = 'video'.! !

!MAFileModel methodsFor: 'convenience' stamp: 'lr 8/10/2005 18:17'!
maintype
	^ self mimetype copyUpTo: $/.! !

!MAFileModel methodsFor: 'accessing' stamp: 'lr 8/10/2005 19:36'!
mimetype
	^ mimetype ifNil: [ self class mimetypeFor: self extension ].! !

!MAFileModel methodsFor: 'accessing' stamp: 'lr 8/10/2005 18:15'!
mimetype: aString
	mimetype := aString! !

!MAFileModel methodsFor: 'convenience' stamp: 'lr 8/10/2005 20:17'!
size
	^ self contents size.! !

!MAFileModel methodsFor: 'convenience' stamp: 'lr 8/10/2005 18:17'!
subtype
	^ self mimetype copyAfter: $/.! !

!MAFileModel methodsFor: 'comparing' stamp: 'lr 8/10/2005 19:53'!
= anObject
	^ self species = anObject species
		and: [ self contents = anObject contents ]
		and: [ self filename = anObject filename ]
		and: [ self mimetype = anObject mimetype ].! !

Object subclass: #MAObject
	instanceVariableNames: 'properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Core'!

!MAObject commentStamp: '<historical>' prior: 0!
I provide some functions for all magritte objects. Magritte is a powerfull meta-description that allows one to create user-interfaces elements easily. Currently, only a web interface (for Seaside) is actively maintained. But a morph one is already working and it is easy to add new interfaces.

I implement a dictionary of properties.

With Magritte, describe once, display everywhere.!

MAObject subclass: #MAAccessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Accessor'!

!MAAccessor methodsFor: 'testing' stamp: 'lr 5/8/2005 20:29'!
canRead
	^ true! !

!MAAccessor methodsFor: 'testing' stamp: 'lr 5/8/2005 20:29'!
canWrite
	^ true! !

!MAAccessor methodsFor: 'printing' stamp: 'lr 10/18/2005 22:43'!
printOn: aStream
	super printOn: aStream.
	self canRead 
		ifTrue: [ self printReadOn: aStream ].
	self canWrite
		ifTrue: [ self printWriteOn: aStream ].! !

!MAAccessor methodsFor: 'printing' stamp: 'lr 10/18/2005 22:44'!
printReadOn: aStream
	aStream nextPutAll: ' read: {'.
	self printRead: 'aModel' on: aStream.
	aStream nextPut: $}.! !

!MAAccessor methodsFor: 'printing' stamp: 'lr 5/8/2005 20:29'!
printRead: aModel on: aStream! !

!MAAccessor methodsFor: 'printing' stamp: 'lr 10/18/2005 22:44'!
printWriteOn: aStream
	aStream nextPutAll: ' write: {'.
	self printWrite: 'anObject' to: 'aModel' on: aStream.
	aStream nextPut: $}.! !

!MAAccessor methodsFor: 'printing' stamp: 'lr 5/8/2005 20:29'!
printWrite: anObject to: aModel on: aStream! !

!MAAccessor methodsFor: 'model' stamp: 'lr 8/10/2005 10:49'!
read: aModel
	"Read from aModel using the access-strategy of the receiver."
	
	self subclassResponsibility.! !

!MAAccessor methodsFor: 'model' stamp: 'lr 8/10/2005 10:49'!
write: anObject to: aModel
	"Write to aModel using the access-strategy of the receiver and anObject as value."
	
	self subclassResponsibility.! !

MAAccessor subclass: #MABlockAccessor
	instanceVariableNames: 'readBlock writeBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Accessor'!

!MABlockAccessor class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MABlockAccessor class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
read: aReadBlock write: aWriteBlock
	^ self new
		readBlock: aReadBlock;
		writeBlock: aWriteBlock;
		yourself.! !

!MABlockAccessor methodsFor: 'testing' stamp: 'lr 5/8/2005 20:29'!
canRead
	^ self readBlock notNil.! !

!MABlockAccessor methodsFor: 'testing' stamp: 'lr 5/8/2005 20:29'!
canWrite
	^ self writeBlock notNil.! !

!MABlockAccessor methodsFor: 'comparing' stamp: 'lr 7/7/2005 14:27'!
hash
	^ super hash bitXor: (self readBlock hash bitXor: self writeBlock hash).! !

!MABlockAccessor methodsFor: 'printing' stamp: 'lr 5/8/2005 20:29'!
printBlock: aBlock on: aStream
	aStream nextPutAll: aBlock decompile asString allButFirst allButLast.! !

!MABlockAccessor methodsFor: 'printing' stamp: 'lr 5/8/2005 20:29'!
printRead: aModel on: aStream
	self printBlock: self readBlock on: aStream.
	aStream nextPutAll: ' value: '; nextPutAll: aModel asString.! !

!MABlockAccessor methodsFor: 'printing' stamp: 'lr 5/8/2005 20:29'!
printWrite: anObject to: aModel on: aStream
	self printBlock: self writeBlock on: aStream.
	aStream nextPutAll: ' value: '; nextPutAll: aModel asString.
	aStream nextPutAll: ' value: '; nextPutAll: anObject asString.! !

!MABlockAccessor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
readBlock
	^ readBlock! !

!MABlockAccessor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
readBlock: aBlock
	readBlock := aBlock! !

!MABlockAccessor methodsFor: 'model' stamp: 'lr 5/8/2005 20:29'!
read: aModel
	^ self readBlock value: aModel.! !

!MABlockAccessor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
writeBlock
	^ writeBlock! !

!MABlockAccessor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
writeBlock: aBlock
	writeBlock := aBlock! !

!MABlockAccessor methodsFor: 'model' stamp: 'lr 5/8/2005 20:29'!
write: anObject to: aModel
	self writeBlock value: aModel value: anObject.! !

!MABlockAccessor methodsFor: 'comparing' stamp: 'lr 5/8/2005 20:29'!
= anObject
	^ super = anObject
		and: [ self readBlock = anObject readBlock ]
		and: [ self writeBlock = anObject writeBlock ].! !

MAAccessor subclass: #MACascadeAccessor
	instanceVariableNames: 'accessor next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Accessor'!

!MACascadeAccessor class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
accessor: anAccessor next: aNextAccessor
	^ self new
		accessor: anAccessor;
		next: aNextAccessor; 
		yourself.! !

!MACascadeAccessor class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MACascadeAccessor class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
selectors: anArray
	^ anArray allButLast reverse
		inject: (MASelectorAccessor selector: anArray last)
		into: [ :next :accessor | 
			self 
				accessor: (MASelectorAccessor selector: accessor)
				next: next ].! !

!MACascadeAccessor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
accessor
	^ accessor! !

!MACascadeAccessor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
accessor: anAccessor
	accessor := anAccessor! !

!MACascadeAccessor methodsFor: 'testing' stamp: 'lr 9/12/2005 17:30'!
canRead
	^ self accessor canRead and: [ self next canRead ].! !

!MACascadeAccessor methodsFor: 'testing' stamp: 'lr 9/12/2005 17:30'!
canWrite
	^ self accessor canRead and: [ self next canWrite ].! !

!MACascadeAccessor methodsFor: 'comparing' stamp: 'lr 7/7/2005 14:27'!
hash
	^ super hash bitXor: (self accessor hash bitXor: self next hash).! !

!MACascadeAccessor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
next
	^ next! !

!MACascadeAccessor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
next: anAccessor
	next := anAccessor! !

!MACascadeAccessor methodsFor: 'copying' stamp: 'lr 5/8/2005 20:29'!
postCopy
	super postCopy.
	self accessor: self accessor copy.
	self next: self next copy.! !

!MACascadeAccessor methodsFor: 'printing' stamp: 'lr 5/8/2005 20:29'!
printRead: aModel on: aStream
	self next 
		printRead: (String streamContents: [ :stream |
			self accessor 
				printRead: aModel 
				on: stream ])
		on: aStream.! !

!MACascadeAccessor methodsFor: 'printing' stamp: 'lr 5/8/2005 20:29'!
printWrite: anObject to: aModel on: aStream
	self next
		printWrite: anObject
		to: (String streamContents: [ :stream |
			self accessor
				printRead: aModel
				on: stream ])
		on: aStream.! !

!MACascadeAccessor methodsFor: 'model' stamp: 'lr 5/8/2005 20:29'!
read: aModel
	^ self next read: (self accessor read: aModel).! !

!MACascadeAccessor methodsFor: 'model' stamp: 'lr 5/8/2005 20:29'!
write: anObject to: aModel
	self next write: anObject to: (self accessor read: aModel).! !

!MACascadeAccessor methodsFor: 'comparing' stamp: 'lr 5/8/2005 20:29'!
= anObject
	^ super = anObject
		and: [ self accessor = anObject accessor ]
		and: [ self next = anObject next ].! !

MAAccessor subclass: #MAContainerAccessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Accessor'!

!MAContainerAccessor class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MAContainerAccessor methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
canWrite
	^ false! !

!MAContainerAccessor methodsFor: 'printing' stamp: 'lr 5/8/2005 20:30'!
printRead: aModel on: aStream
	aStream nextPutAll: aModel asString.! !

!MAContainerAccessor methodsFor: 'model' stamp: 'lr 5/8/2005 20:30'!
read: aModel
	^ aModel.! !

!MAContainerAccessor methodsFor: 'model' stamp: 'lr 5/8/2005 20:30'!
write: anObject to: aModel
	self error: 'Not supposed to write to ' , aModel asString , '.'.! !

MAAccessor subclass: #MADictionaryAccessor
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Accessor'!

!MADictionaryAccessor class methodsFor: 'testing' stamp: 'lr 10/10/2005 08:59'!
isAbstract
	^ false! !

!MADictionaryAccessor class methodsFor: 'instance-creation' stamp: 'lr 10/10/2005 09:05'!
key: aSymbol
	^ self new
		key: aSymbol;
		yourself.! !

!MADictionaryAccessor methodsFor: 'comparing' stamp: 'lr 10/3/2005 23:07'!
hash
	^ super hash bitXor: self key hash.! !

!MADictionaryAccessor methodsFor: 'accessing' stamp: 'lr 10/3/2005 23:06'!
key
	^ key! !

!MADictionaryAccessor methodsFor: 'accessing' stamp: 'lr 10/3/2005 23:07'!
key: aKey 
	key := aKey! !

!MADictionaryAccessor methodsFor: 'printing' stamp: 'lr 10/3/2005 23:09'!
printRead: aModel on: aStream
	aStream 
		nextPutAll: aModel asString;
		nextPutAll: ' at: '; print: self key;
		nextPutAll: ' ifAbsent: [ nil ]'.! !

!MADictionaryAccessor methodsFor: 'printing' stamp: 'lr 10/3/2005 23:10'!
printWrite: anObject to: aModel on: aStream
	aStream 
		nextPutAll: aModel asString; 
		nextPutAll: ' at: '; print: self key;
		nextPutAll: ' put: '; nextPutAll: anObject asString.! !

!MADictionaryAccessor methodsFor: 'model' stamp: 'lr 10/3/2005 23:08'!
read: aModel
	^ aModel at: self key ifAbsent: [ nil ].! !

!MADictionaryAccessor methodsFor: 'model' stamp: 'lr 10/3/2005 23:08'!
write: anObject to: aModel
	aModel at: self key put: anObject.! !

!MADictionaryAccessor methodsFor: 'comparing' stamp: 'lr 10/3/2005 23:07'!
= anObject
	^ super = anObject
		and: [ self name = anObject name ].! !

MAAccessor subclass: #MANullAccessor
	instanceVariableNames: 'uuid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Accessor'!

!MANullAccessor class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MANullAccessor class methodsFor: 'instance-creation' stamp: 'lr 11/7/2005 18:05'!
new
	^ self uuid: MACompatibility uuid.! !

!MANullAccessor class methodsFor: 'instance-creation' stamp: 'lr 8/25/2005 10:20'!
uuid: anUUID
	^ self basicNew
		uuid: anUUID;
		yourself.! !

!MANullAccessor methodsFor: 'testing' stamp: 'lr 5/8/2005 20:31'!
canRead
	^ false! !

!MANullAccessor methodsFor: 'testing' stamp: 'lr 5/8/2005 20:31'!
canWrite
	^ false! !

!MANullAccessor methodsFor: 'comparing' stamp: 'lr 8/25/2005 10:19'!
hash
	^ super hash bitXor: self uuid hash.! !

!MANullAccessor methodsFor: 'printing' stamp: 'lr 8/25/2005 10:22'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' uuid: '; print: self uuid.! !

!MANullAccessor methodsFor: 'model' stamp: 'lr 9/14/2005 23:39'!
read: aModel
	self shouldNotImplement.! !

!MANullAccessor methodsFor: 'accessing' stamp: 'lr 7/7/2005 14:26'!
uuid
	^ uuid! !

!MANullAccessor methodsFor: 'accessing' stamp: 'lr 7/7/2005 14:29'!
uuid: anObject
	uuid := anObject! !

!MANullAccessor methodsFor: 'model' stamp: 'lr 9/14/2005 23:39'!
write: anObject to: aModel
	self shouldNotImplement.! !

!MANullAccessor methodsFor: 'comparing' stamp: 'lr 8/25/2005 10:19'!
= anObject
	^ super = anObject
		and: [ self uuid = anObject uuid ].! !

MAAccessor subclass: #MASelectorAccessor
	instanceVariableNames: 'readSelector writeSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Accessor'!

MASelectorAccessor subclass: #MAAutoSelectorAccessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Accessor'!

!MAAutoSelectorAccessor methodsFor: 'private' stamp: 'lr 11/8/2005 14:39'!
ensureReadAccessor: aClass
	(aClass selectors includes: self readSelector)
		ifTrue: [ ^ self ].
	aClass 
		compile: (String streamContents: [ :stream |
			stream nextPutAll: self readSelector; cr.
			stream tab; nextPutAll: '^ '; nextPutAll: self readSelector ])
		classified: #'accessing-generated'.! !

!MAAutoSelectorAccessor methodsFor: 'private' stamp: 'lr 10/19/2005 20:50'!
ensureVariable: aClass
	(aClass allInstVarNames includes: self readSelector)
		ifTrue: [ ^ self ].
	aClass addInstVarName: self readSelector.! !

!MAAutoSelectorAccessor methodsFor: 'private' stamp: 'lr 11/8/2005 14:39'!
ensureWriteAccessor: aClass
	(aClass selectors includes: self writeSelector)
		ifTrue: [ ^ self ].
	aClass 
		compile: (String streamContents: [ :stream |
			stream nextPutAll: self writeSelector; space; nextPutAll: 'anObject'; cr.				
			stream tab; nextPutAll: self readSelector; nextPutAll: ' := anObject' ])
		classified: #'accessing-generated'.! !

!MAAutoSelectorAccessor methodsFor: 'model' stamp: 'lr 10/19/2005 22:12'!
read: aModel
	self 
		ensureVariable: aModel class;
		ensureReadAccessor: aModel class.
	^ super read: aModel.! !

!MAAutoSelectorAccessor methodsFor: 'model' stamp: 'lr 10/19/2005 22:13'!
write: anObject to: aModel
	self 
		ensureVariable: aModel class; 
		ensureWriteAccessor: aModel class.
	super write: anObject to: aModel.! !

!MASelectorAccessor class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:34'!
isAbstract
	^ false! !

!MASelectorAccessor class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:34'!
read: aReadSelector write: aWriteSelector
	^ self new
		readSelector: aReadSelector;
		writeSelector: aWriteSelector;
		yourself.! !

!MASelectorAccessor class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:34'!
selector: aSelector
	^ self new
		selector: aSelector;
		yourself.! !

!MASelectorAccessor methodsFor: 'testing' stamp: 'lr 5/8/2005 20:32'!
canRead
	^ self readSelector notNil.! !

!MASelectorAccessor methodsFor: 'testing' stamp: 'lr 5/8/2005 20:32'!
canWrite
	^ self writeSelector notNil.! !

!MASelectorAccessor methodsFor: 'comparing' stamp: 'lr 7/7/2005 14:28'!
hash
	^  super hash bitXor: (self readSelector hash bitXor: self writeSelector hash).! !

!MASelectorAccessor methodsFor: 'printing' stamp: 'lr 5/8/2005 20:32'!
printRead: aModel on: aStream
	aStream nextPutAll: aModel asString; space.
	aStream nextPutAll: self readSelector.! !

!MASelectorAccessor methodsFor: 'printing' stamp: 'lr 7/14/2005 11:43'!
printWrite: anObject to: aModel on: aStream
	aStream nextPutAll: aModel asString; space.
	aStream nextPutAll: self writeSelector; space.
	aStream nextPutAll: anObject asString.! !

!MASelectorAccessor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
readSelector
	^ readSelector! !

!MASelectorAccessor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
readSelector: aSelector
	readSelector := aSelector.! !

!MASelectorAccessor methodsFor: 'model' stamp: 'lr 5/8/2005 20:32'!
read: aModel
	^ aModel perform: self readSelector.! !

!MASelectorAccessor methodsFor: 'accessing-dynamic' stamp: 'lr 5/8/2005 20:32'!
selector
	^ self readSelector.! !

!MASelectorAccessor methodsFor: 'accessing-dynamic' stamp: 'lr 5/8/2005 20:32'!
selector: aSelector
	self readSelector: aSelector asSymbol.
	self writeSelector: (aSelector copyWith: $:) asSymbol.! !

!MASelectorAccessor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
writeSelector
	^ writeSelector! !

!MASelectorAccessor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
writeSelector: aSelector
	writeSelector := aSelector.! !

!MASelectorAccessor methodsFor: 'model' stamp: 'lr 5/8/2005 20:32'!
write: anObject to: aModel
	aModel perform: self writeSelector with: anObject.! !

!MASelectorAccessor methodsFor: 'comparing' stamp: 'lr 5/8/2005 20:32'!
= anObject
	^ super = anObject
		and: [ self readSelector = anObject readSelector ]
		and: [ self writeSelector = anObject writeSelector ].! !

MAAccessor subclass: #MAVariableAccessor
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Accessor'!

!MAVariableAccessor class methodsFor: 'testing' stamp: 'lr 5/9/2005 13:43'!
isAbstract
	^ false! !

!MAVariableAccessor class methodsFor: 'instance creation' stamp: 'lr 5/9/2005 13:43'!
name: aString
	^ self new
		name: aString;
		yourself.! !

!MAVariableAccessor methodsFor: 'comparing' stamp: 'lr 5/9/2005 13:38'!
hash
	^ super hash bitXor: self name hash.! !

!MAVariableAccessor methodsFor: 'accessing' stamp: 'lr 5/9/2005 13:37'!
name
	^ name! !

!MAVariableAccessor methodsFor: 'accessing' stamp: 'lr 5/9/2005 13:37'!
name: aString
	name := aString! !

!MAVariableAccessor methodsFor: 'printing' stamp: 'lr 5/9/2005 13:42'!
printRead: aModel on: aStream
	aStream 
		nextPutAll: aModel asString;
		nextPutAll: ' instVarNamed: '; print: self name.! !

!MAVariableAccessor methodsFor: 'printing' stamp: 'lr 7/14/2005 11:43'!
printWrite: anObject to: aModel on: aStream
	aStream 
		nextPutAll: aModel asString; 
		nextPutAll: ' instVarNamed: '; print: self name;
		nextPutAll: ' put: '; nextPutAll: anObject asString.! !

!MAVariableAccessor methodsFor: 'model' stamp: 'lr 5/9/2005 13:38'!
read: aModel
	^ aModel instVarNamed: self name.! !

!MAVariableAccessor methodsFor: 'model' stamp: 'lr 5/9/2005 13:39'!
write: anObject to: aModel
	aModel instVarNamed: self name put: anObject.! !

!MAVariableAccessor methodsFor: 'comparing' stamp: 'lr 5/9/2005 13:38'!
= anObject
	^ super = anObject
		and: [ self name = anObject name ].! !

MAObject subclass: #MADescription
	instanceVariableNames: 'accessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Description'!

!MADescription commentStamp: '<historical>' prior: 0!
I'm the base class of Magritte. All the descriptions of magritte are my subclasses. If you want one of your objects to have a user interface for an elements, find the most approriate of my subclasses. 

For example, your application need to ask a string to the user, use MAStringDescription. Create two methods to retrieve and store the string in you class and then create a method on the class side with a name begining with 'description', like this.

MyClass class>>descriptionTitle
	^ (MAStringDescription selector: #title label: 'Title' priority: 100)
		beRequired;
		yourself.

The selector #title is the name of the reader method, to retrieve the current value of the string (the default value if you prefer).
The writer is automatically guessed adding ':' to the reader, here #title:. You can specify you own writer using the MAAccessor classes (look at MADescription>>selector:label:priority: and MAAccessor subclasses).
The label is what will be printed near the input box to inform the user about what to do here.
If you have multiple description within the same object, the priority field is used to order them. Put a low priority for description printed first.

You can then add more properties to your description depending on the type of this description. All descriptions have those basic properties:
- required: Your user has to fill this field before being able to go on. Set or unset this propertie with beRequired or beOptional. Default: false.
- readonly: It is just an information, nothing to modify here. beReadonly/beWriteable. Default: false.
- visible: Does this description need to be displayed to the user ? beVisible/beHidden. Default: true.!

MADescription subclass: #MAContainer
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Description'!

!MAContainer commentStamp: 'lr 5/5/2005 10:12' prior: 0!
A container is a composition of different descriptions, that fully supports the collection protocol.!

!MAContainer class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultAccessor
	^ MAContainerAccessor new.! !

!MAContainer class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultCollection
	^ OrderedCollection new.! !

!MAContainer class methodsFor: 'accessing-description' stamp: 'lr 10/30/2005 19:31'!
descriptionChildren
	^ (MAOneToManyRelationDescription accessor: (MASelectorAccessor read: #children write: #setChildren:) label: 'Elements' priority: 400 default: self defaultCollection)
		classes: (MADynamicObject on: [ MAElementDescription withAllConcreteClasses ]);
		yourself.! !

!MAContainer class methodsFor: 'accessing-description' stamp: 'lr 8/11/2005 17:26'!
descriptionDefault
	^ nil! !

!MAContainer class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MAContainer class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
withAll: aCollection
	^ self new
		addAll: aCollection;
		yourself.! !

!MAContainer class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
with: aDescription
	^ self new
		add: aDescription;
		yourself.! !

!MAContainer methodsFor: 'visiting' stamp: 'lr 10/29/2005 20:48'!
acceptMagritte: aVisitor
	aVisitor visitContainer: self.! !

!MAContainer methodsFor: 'adding' stamp: 'lr 10/18/2005 22:34'!
addAll: aCollection
	self children addAll: aCollection.! !

!MAContainer methodsFor: 'adding' stamp: 'lr 5/8/2005 20:30'!
add: aDescription
	self children add: aDescription.! !

!MAContainer methodsFor: 'converting' stamp: 'lr 5/8/2005 20:30'!
asContainer
	^ self! !

!MAContainer methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:30'!
at: anIndex
	^ self children at: anIndex.! !

!MAContainer methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:30'!
at: anIndex ifAbsent: aBlock
	^ self children at: anIndex ifAbsent: aBlock.! !

!MAContainer methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:30'!
children
	^ children! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 5/8/2005 20:30'!
collect: aBlock
	^ self copy 
		setChildren: (self children collect: aBlock);
		yourself.! !

!MAContainer methodsFor: 'copying' stamp: 'lr 9/27/2005 07:30'!
copyEmpty
	^ self copy 
		setChildren: self class defaultChildren;
		yourself.! !

!MAContainer methodsFor: 'copying' stamp: 'lr 5/8/2005 20:30'!
copyFrom: aStartIndex to: anEndIndex
	^ self copy 
		setChildren: (self children
			copyFrom: aStartIndex 
			to: anEndIndex);
		yourself.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 5/8/2005 20:30'!
detect: aBlock 
	^ self children detect: aBlock.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 5/8/2005 20:30'!
detect: aBlock ifNone: anExceptionBlock 
	^ self children detect: aBlock ifNone: anExceptionBlock.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 5/8/2005 20:30'!
do: aBlock
	self children do: aBlock.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 5/8/2005 20:30'!
do: aBlock separatedBy: aSeparatorBlock
	self children do: aBlock separatedBy: aSeparatorBlock.! !

!MAContainer methodsFor: 'private' stamp: 'lr 10/29/2005 22:00'!
errorNotFound: aDescription
	self error: aDescription class label , ' not found.'.! !

!MAContainer methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
hasChildren
	^ self notEmpty.! !

!MAContainer methodsFor: 'comparing' stamp: 'lr 5/8/2005 20:30'!
hash
	^ super hash bitXor: self children hash.! !

!MAContainer methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
includes: aDescription
	^ self children includes: aDescription.! !

!MAContainer methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:30'!
initialize
	super initialize.
	self setChildren: self class defaultCollection.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 5/8/2005 20:30'!
inject: anObject into: aBlock 
	^ self children inject: anObject into: aBlock.! !

!MAContainer methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
isContainer	
	^ true! !

!MAContainer methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
isEmpty
	^ self children isEmpty.! !

!MAContainer methodsFor: 'moving' stamp: 'lr 5/8/2005 20:30'!
moveDown: aDescription
	self children moveDown: aDescription.! !

!MAContainer methodsFor: 'moving' stamp: 'lr 5/8/2005 20:30'!
moveUp: aDescription
	self children moveUp: aDescription.! !

!MAContainer methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
notEmpty
	^ self children notEmpty.! !

!MAContainer methodsFor: 'copying' stamp: 'lr 5/8/2005 20:30'!
postCopy
	super postCopy.
	self setChildren: self children copy.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 9/12/2005 16:24'!
reject: aBlock
	^ self copy
		setChildren: (self children reject: aBlock);
		yourself.! !

!MAContainer methodsFor: 'removing' stamp: 'lr 9/12/2005 16:25'!
removeAll
	self setChildren: self class defaultCollection.! !

!MAContainer methodsFor: 'removing' stamp: 'lr 5/8/2005 20:30'!
remove: aDescription
	self children remove: aDescription ifAbsent: [ self errorNotFound: aDescription ].! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 5/8/2005 20:30'!
select: aBlock
	^ self copy 
		setChildren: (self children select: aBlock);
		yourself.! !

!MAContainer methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:30'!
setChildren: aCollection
	children := aCollection! !

!MAContainer methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:30'!
size
	^ self children size.! !

!MAContainer methodsFor: 'validating' stamp: 'lr 10/29/2005 22:11'!
validateSpecific: anObject
	| errors |
	super validateSpecific: anObject.
	errors := Array streamContents: [ :stream |
		self do: [ :each |
			each isVisible ifTrue: [
				[ each validate: (anObject readUsing: each) ]
					on: MAValidationError 
					do: [ :err | stream nextPut: err ] ] ] ].
	errors isEmpty
		ifFalse: [ MAMultipleErrors on: self errors: errors ].! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 5/8/2005 20:30'!
withIndexDo: aBlock
	self children withIndexDo: aBlock.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 5/8/2005 20:30'!
with: aCollection do: aBlock
	self children with: aCollection do: aBlock.! !

!MAContainer methodsFor: 'comparing' stamp: 'lr 5/8/2005 20:30'!
= anObject
	^ super = anObject
		and: [ self children = anObject children ].! !

MAContainer subclass: #MAPriorityContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Description'!

!MAPriorityContainer class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultCollection
	^ SortedCollection new.! !

!MAPriorityContainer methodsFor: 'visiting' stamp: 'lr 10/29/2005 20:48'!
acceptMagritte: aVisitor
	aVisitor visitPriorityContainer: self.! !

!MAPriorityContainer methodsFor: 'moving' stamp: 'lr 5/8/2005 20:31'!
moveDown: aDescription
	aDescription priority: aDescription priority - 1.
	self resort.! !

!MAPriorityContainer methodsFor: 'moving' stamp: 'lr 5/8/2005 20:31'!
moveUp: aDescription
	aDescription priority: aDescription priority + 1.
	self resort.! !

!MAPriorityContainer methodsFor: 'actions' stamp: 'lr 5/8/2005 20:31'!
resort
	self setChildren: self children copy.! !

!MAPriorityContainer methodsFor: 'initialization' stamp: 'lr 7/7/2005 15:21'!
setChildren: aCollection
	super setChildren: aCollection asSortedCollection.! !

MAContainer subclass: #MAReportContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Description'!

!MAReportContainer class methodsFor: 'accessing-defaults-table' stamp: 'lr 5/8/2005 20:33'!
defaultCaption
	^ nil! !

!MAReportContainer class methodsFor: 'accessing-defaults-table' stamp: 'lr 5/8/2005 20:34'!
defaultEmpty
	^ 'The report is empty.'! !

!MAReportContainer class methodsFor: 'accessing-defaults-batch' stamp: 'lr 5/8/2005 20:33'!
defaultPageSize
	^ 10! !

!MAReportContainer class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultShowBatch
	^ true! !

!MAReportContainer class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:34'!
defaultShowFooter
	^ false! !

!MAReportContainer class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:34'!
defaultShowHeader
	^ true! !

!MAReportContainer class methodsFor: 'accessing-defaults-table' stamp: 'lr 5/8/2005 20:34'!
defaultSummary
	^ nil! !

!MAReportContainer class methodsFor: 'accessing-description-table' stamp: 'lr 5/8/2005 20:33'!
descriptionCaption
	^ MAStringDescription selector: #caption label: 'Caption' priority: 1000 default: self defaultCaption.! !

!MAReportContainer class methodsFor: 'accessing-description-table' stamp: 'lr 5/8/2005 20:34'!
descriptionEmpty
	^ MAStringDescription selector: #empty label: 'Empty' priority: 1200 default: self defaultEmpty.! !

!MAReportContainer class methodsFor: 'accessing-description-batch' stamp: 'lr 5/8/2005 20:34'!
descriptionPageSize
	^ MANumberDescription selector: #pageSize label: 'Page Size' priority: 2000 default: self defaultPageSize.! !

!MAReportContainer class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:33'!
descriptionShowBatch
	^ MABooleanDescription selector: #showBatch label: 'Show Batch' priority: 3200 default: self defaultShowBatch.! !

!MAReportContainer class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:33'!
descriptionShowFooter
	^ MABooleanDescription selector: #showFooter label: 'Show Footer' priority: 3100 default: self defaultShowFooter.! !

!MAReportContainer class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:34'!
descriptionShowHeader
	^ MABooleanDescription selector: #showHeader label: 'Show Header' priority: 3000 default: self defaultShowHeader.! !

!MAReportContainer class methodsFor: 'accessing-description-table' stamp: 'lr 5/8/2005 20:34'!
descriptionSummary
	^ MAStringDescription selector: #summary label: 'Summary' priority: 1100 default: self defaultSummary.! !

!MAReportContainer methodsFor: 'visiting' stamp: 'lr 10/29/2005 20:48'!
acceptMagritte: aVisitor
	aVisitor visitReportContainer: self.! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 5/8/2005 20:32'!
caption
	^ self propertyAt: #caption ifAbsent: [ self class defaultCaption ].! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 5/8/2005 20:32'!
caption: aString
	self propertyAt: #caption put: aString.! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 5/8/2005 20:32'!
empty
	^ self propertyAt: #empty ifAbsent: [ self class defaultEmpty ].! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 5/8/2005 20:32'!
empty: aString
	self propertyAt: #empty put: aString.! !

!MAReportContainer methodsFor: 'accessing-batch' stamp: 'lr 5/8/2005 20:32'!
pageSize
	^ self propertyAt: #pageSize ifAbsent: [ self class defaultPageSize ].! !

!MAReportContainer methodsFor: 'accessing-batch' stamp: 'lr 5/8/2005 20:32'!
pageSize: aNumber
	self propertyAt: #pageSize put: aNumber.! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
showBatch
	^ self propertyAt: #showBatch ifAbsent: [ self class defaultShowBatch ].! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
showBatch: aBoolean
	self propertyAt: #showBatch put: aBoolean.! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
showFooter
	^ self propertyAt: #showFooter ifAbsent: [ self class defaultShowFooter ].! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
showFooter: aBoolean
	self propertyAt: #showFooter put: aBoolean.! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
showHeader
	^ self propertyAt: #showHeader ifAbsent: [ self class defaultShowHeader ].! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
showHeader: aBoolean
	self propertyAt: #showHeader put: aBoolean.! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 5/8/2005 20:32'!
summary
	^ self propertyAt: #summary ifAbsent: [ self class defaultSummary ].! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 5/8/2005 20:32'!
summary: aString
	self propertyAt: #summary put: aString.! !

!MADescription class methodsFor: 'instance-creation-accessor' stamp: 'lr 5/8/2005 20:33'!
accessor: anAccessor
	^ self accessor: anAccessor label: self defaultLabel.! !

!MADescription class methodsFor: 'instance-creation-accessor' stamp: 'lr 5/8/2005 20:33'!
accessor: anAccessor label: aString
	^ self accessor: anAccessor label: aString priority: self defaultPriority.! !

!MADescription class methodsFor: 'instance-creation-accessor' stamp: 'lr 5/8/2005 20:33'!
accessor: anAccessor label: aString priority: aNumber
	^ self accessor: anAccessor label: aString priority: aNumber default: self defaultDefault.! !

!MADescription class methodsFor: 'instance-creation-accessor' stamp: 'lr 5/8/2005 20:33'!
accessor: anAccessor label: aString priority: aNumber default: anObject
	^ self new
		accessor: anAccessor;
		label: aString;
		priority: aNumber;
		default: anObject;
		yourself.! !

!MADescription class methodsFor: 'instance-creation-auto' stamp: 'lr 6/14/2005 23:37'!
auto: aSelector
	^ self accessor: (MAAutoSelectorAccessor selector: aSelector).! !

!MADescription class methodsFor: 'instance-creation-auto' stamp: 'lr 6/14/2005 23:37'!
auto: aSelector label: aString
	^ self accessor: (MAAutoSelectorAccessor selector: aSelector) label: aString.! !

!MADescription class methodsFor: 'instance-creation-auto' stamp: 'lr 6/14/2005 23:37'!
auto: aSelector label: aString priority: aNumber
	^ self accessor: (MAAutoSelectorAccessor selector: aSelector) label: aString priority: aNumber.! !

!MADescription class methodsFor: 'instance-creation-auto' stamp: 'lr 6/14/2005 23:37'!
auto: aSelector label: aString priority: aNumber default: anObject
	^ self accessor: (MAAutoSelectorAccessor selector: aSelector) label: aString priority: aNumber default: anObject.! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 8/25/2005 10:22'!
defaultAccessor
	^ MANullAccessor new.! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultComment
	^ nil! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 10/27/2005 15:09'!
defaultConditions
	^ Array new.! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultDefault
	^ nil! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultLabel
	^ nil! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 10/13/2005 17:47'!
defaultPersistent
	^ true! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultPriority
	^ 0! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultReadonly
	^ false! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultRequired
	^ false! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 10/20/2005 00:16'!
defaultStringReader
	^ MAStringReader! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 10/20/2005 00:15'!
defaultStringWriter
	^ MAStringWriter! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 10/20/2005 00:15'!
defaultUndefined
	^ String new.! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultVisible
	^ true! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:33'!
descriptionComment
	^ MATextDescription selector: #comment label: 'Comment' priority: 110 default: self defaultComment.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 9/13/2005 22:18'!
descriptionDefault
	^ self isAbstract 
		ifFalse: [ self selector: #default label: 'Default' priority: 130 default: self defaultDefault ].! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:33'!
descriptionLabel
	^ MAStringDescription selector: #label label: 'Label' priority: 100 default: self defaultLabel.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 10/13/2005 17:48'!
descriptionPersistent
	^ MABooleanDescription selector: #persistent label: 'Persistent' priority: 230 default: self defaultPersistent.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 10/28/2005 17:15'!
descriptionPriority
	^ (MANumberDescription selector: #priority label: 'Priority' priority: 130 default: self defaultPriority)
		beRequired;
		yourself.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 9/13/2005 23:52'!
descriptionReadonly
	^ MABooleanDescription selector: #readonly label: 'Readonly' priority: 200 default: self defaultReadonly.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 9/13/2005 23:52'!
descriptionRequired
	^ MABooleanDescription selector: #required label: 'Required' priority: 220 default: self defaultRequired.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 10/20/2005 00:15'!
descriptionStringReader
	^ (MASingleOptionDescription selector: #stringReader label: 'String Reader' priority: 300 default: self defaultStringReader)
		reference: MAClassDescription new;
		options: (MADynamicObject on: [ self defaultStringReader withAllSubclasses ]);
		yourself.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 10/20/2005 00:15'!
descriptionStringWriter
	^ (MASingleOptionDescription selector: #stringWriter label: 'String Writer' priority: 310 default: self defaultStringWriter)
		reference: MAClassDescription new;
		options: (MADynamicObject on: [ self defaultStringWriter withAllSubclasses ]);
		yourself.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 10/20/2005 00:15'!
descriptionUndefined
	^ MAStringDescription selector: #undefined label: 'Undefined String' priority: 140 default: self defaultUndefined.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 9/13/2005 23:52'!
descriptionVisible
	^ MABooleanDescription selector: #visible label: 'Visible' priority: 210 default: self defaultVisible.! !

!MADescription class methodsFor: 'instance-creation-null' stamp: 'lr 11/7/2005 18:05'!
null
	^ self accessor: (MANullAccessor uuid: MACompatibility uuid).! !

!MADescription class methodsFor: 'instance-creation-null' stamp: 'lr 7/7/2005 14:24'!
null: anUuid
	^ self accessor: (MANullAccessor uuid: anUuid).! !

!MADescription class methodsFor: 'instance-creation-null' stamp: 'lr 7/7/2005 14:25'!
null: anUuid label: aString
	^ self accessor: (MANullAccessor uuid: anUuid) label: aString.! !

!MADescription class methodsFor: 'instance-creation-null' stamp: 'lr 7/7/2005 14:25'!
null: anUuid label: aString priority: aNumber
	^ self accessor: (MANullAccessor uuid: anUuid) label: aString priority: aNumber.! !

!MADescription class methodsFor: 'instance-creation-null' stamp: 'lr 7/7/2005 14:25'!
null: anUuid label: aString priority: aNumber default: anObject
	^ self accessor: (MANullAccessor uuid: anUuid) label: aString priority: aNumber default: anObject.! !

!MADescription class methodsFor: 'instance-creation-block' stamp: 'lr 5/8/2005 20:33'!
read: aReadBlock write: aWriteBlock
	^ self accessor: (MABlockAccessor read: aReadBlock write: aWriteBlock).! !

!MADescription class methodsFor: 'instance-creation-block' stamp: 'lr 5/8/2005 20:33'!
read: aReadBlock write: aWriteBlock label: aString
	^ self accessor: (MABlockAccessor read: aReadBlock write: aWriteBlock) label: aString.! !

!MADescription class methodsFor: 'instance-creation-block' stamp: 'lr 5/8/2005 20:33'!
read: aReadBlock write: aWriteBlock label: aString priority: aNumber
	^ self accessor: (MABlockAccessor read: aReadBlock write: aWriteBlock) label: aString priority: aNumber.! !

!MADescription class methodsFor: 'instance-creation-block' stamp: 'lr 5/8/2005 20:33'!
read: aReadBlock write: aWriteBlock label: aString priority: aNumber default: anObject
	^ self accessor: (MABlockAccessor read: aReadBlock write: aWriteBlock) label: aString priority: aNumber default: anObject.! !

!MADescription class methodsFor: 'instance-creation-cascade' stamp: 'lr 5/8/2005 20:33'!
selectors: anArray
	^ self accessor: (MACascadeAccessor selectors: anArray).! !

!MADescription class methodsFor: 'instance-creation-cascade' stamp: 'lr 5/8/2005 20:33'!
selectors: anArray label: aString
	^ self accessor: (MACascadeAccessor selectors: anArray) label: aString.! !

!MADescription class methodsFor: 'instance-creation-cascade' stamp: 'lr 5/8/2005 20:33'!
selectors: anArray label: aString priority: aNumber
	^ self accessor: (MACascadeAccessor selectors: anArray) label: aString priority: aNumber.! !

!MADescription class methodsFor: 'instance-creation-cascade' stamp: 'lr 5/8/2005 20:33'!
selectors: anArray label: aString priority: aNumber default: anObject
	^ self accessor: (MACascadeAccessor selectors: anArray) label: aString priority: aNumber default: anObject.! !

!MADescription class methodsFor: 'instance-creation-selector' stamp: 'lr 5/8/2005 20:33'!
selector: aSelector
	^ self accessor: (MASelectorAccessor selector: aSelector).! !

!MADescription class methodsFor: 'instance-creation-selector' stamp: 'lr 5/8/2005 20:33'!
selector: aSelector label: aString
	^ self accessor: (MASelectorAccessor selector: aSelector) label: aString.! !

!MADescription class methodsFor: 'instance-creation-selector' stamp: 'lr 5/8/2005 20:33'!
selector: aSelector label: aString priority: aNumber
	^ self accessor: (MASelectorAccessor selector: aSelector) label: aString priority: aNumber.! !

!MADescription class methodsFor: 'instance-creation-selector' stamp: 'lr 5/8/2005 20:33'!
selector: aSelector label: aString priority: aNumber default: anObject
	^ self accessor: (MASelectorAccessor selector: aSelector) label: aString priority: aNumber default: anObject.! !

!MADescription class methodsFor: 'instance-creation-variable' stamp: 'lr 10/18/2005 22:46'!
variable: aSymbol
	^ self accessor: (MAVariableAccessor name: aSymbol).! !

!MADescription class methodsFor: 'instance-creation-variable' stamp: 'lr 10/18/2005 22:32'!
variable: aSymbol label: aString
	^ self accessor: (MAVariableAccessor name: aSymbol) label: aString.! !

!MADescription class methodsFor: 'instance-creation-variable' stamp: 'lr 10/18/2005 22:32'!
variable: aSymbol label: aString priority: aNumber
	^ self accessor: (MAVariableAccessor name: aSymbol) label: aString priority: aNumber.! !

!MADescription class methodsFor: 'instance-creation-variable' stamp: 'lr 10/18/2005 22:33'!
variable: aSymbol label: aString priority: aNumber default: anObject
	^ self accessor: (MAVariableAccessor name: aSymbol) label: aString priority: aNumber default: anObject.! !

!MADescription class methodsFor: 'accessing' stamp: 'lr 10/13/2005 16:43'!
version
	^ 1! !

!MADescription methodsFor: 'visiting' stamp: 'lr 10/29/2005 20:48'!
acceptMagritte: aVisitor
	aVisitor visitDescription: self.! !

!MADescription methodsFor: 'accessing' stamp: 'lr 7/7/2005 13:47'!
accessor
	^ accessor ifNil: [ accessor := self class defaultAccessor ].! !

!MADescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:30'!
accessor: anAccessor	
	accessor := anAccessor! !

!MADescription methodsFor: 'validation' stamp: 'lr 10/27/2005 15:58'!
addCondition: aRelation
	self addCondition: aRelation labelled: aRelation asString.! !

!MADescription methodsFor: 'validation' stamp: 'lr 10/27/2005 15:58'!
addCondition: aRelation labelled: aString
	self conditions: (self conditions copyWith: aRelation asRelation -> aString).! !

!MADescription methodsFor: 'converting' stamp: 'lr 5/8/2005 20:30'!
asContainer
	self subclassResponsibility.! !

!MADescription methodsFor: 'actions' stamp: 'lr 10/13/2005 17:50'!
beEphemeral
	self persistent: false.! !

!MADescription methodsFor: 'actions' stamp: 'lr 5/8/2005 20:30'!
beHidden
	self visible: false.! !

!MADescription methodsFor: 'actions' stamp: 'lr 5/8/2005 20:30'!
beOptional
	self required: false.! !

!MADescription methodsFor: 'actions' stamp: 'lr 10/13/2005 17:49'!
bePersistent
	self persistent: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 10/13/2005 17:54'!
beReadonly
	self readonly: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 5/8/2005 20:30'!
beRequired
	self required: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 5/8/2005 20:30'!
beVisible
	self visible: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 5/8/2005 20:30'!
beWriteable
	self readonly: false.! !

!MADescription methodsFor: 'private' stamp: 'lr 10/28/2005 17:21'!
collectionToString: aCollection
	^ String streamContents: [ :stream |
		aCollection
			do: [ :each | stream nextPutAll: each ]
			separatedBy: [ stream cr ] ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
comment	
	^ self propertyAt: #comment ifAbsent: [ self class defaultComment ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
comment: aString
	self propertyAt: #comment put: aString.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 10/27/2005 15:09'!
conditions
	^ self propertyAt: #conditions ifAbsent: [ self class defaultConditions ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 10/27/2005 15:09'!
conditions: anArray
	self propertyAt: #conditions put: anArray.! !

!MADescription methodsFor: 'strings' stamp: 'lr 10/20/2005 00:12'!
fromString: aString
	^ self fromString: aString reader: self stringReader.! !

!MADescription methodsFor: 'strings' stamp: 'lr 10/20/2005 00:12'!
fromString: aString reader: aParser
	^ aParser read: aString readStream description: self.! !

!MADescription methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
hasChildren
	^ false! !

!MADescription methodsFor: 'testing' stamp: 'lr 9/15/2005 12:57'!
hasComment
	^ self comment isEmptyOrNil not.! !

!MADescription methodsFor: 'comparing' stamp: 'lr 7/7/2005 14:22'!
hash
	^ super hash bitXor: self accessor hash.! !

!MADescription methodsFor: 'testing' stamp: 'lr 9/15/2005 12:56'!
hasLabel
	^ self label isEmptyOrNil not.! !

!MADescription methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
isContainer	
	^ false! !

!MADescription methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
isDescription
	^ true! !

!MADescription methodsFor: 'testing' stamp: 'lr 10/13/2005 17:49'!
isPersistent
	^ self persistent.! !

!MADescription methodsFor: 'testing' stamp: 'lr 10/13/2005 17:49'!
isReadonly
	^ self readonly.! !

!MADescription methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
isRequired
	^ self required.! !

!MADescription methodsFor: 'validation' stamp: 'lr 9/17/2005 16:35'!
isSatisfiedBy: anObject
	" Return true if anObject is a valid instance of the receiver, false otherwise. "
	
	[ self validate: anObject ]
		on: MAValidationError
		do: [ :err | ^ false ].
	^ true.! !

!MADescription methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
isVisible
	^ self visible.! !

!MADescription methodsFor: 'accessing-configuration' stamp: 'lr 5/8/2005 20:30'!
kind
	^ Object! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
label	
	^ self propertyAt: #label ifAbsent: [ self class defaultLabel ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
label: aString
	self propertyAt: #label put: aString.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 10/13/2005 17:47'!
persistent	
	^ self propertyAt: #persistent ifAbsent: [ self class defaultPersistent ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 10/13/2005 17:47'!
persistent: aBoolean	
	self propertyAt: #persistent put: aBoolean.! !

!MADescription methodsFor: 'copying' stamp: 'lr 7/7/2005 14:23'!
postCopy
	super postCopy.
	self accessor: self accessor copy.! !

!MADescription methodsFor: 'printing' stamp: 'lr 9/19/2005 19:36'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' label: '; print: self label.
	aStream nextPutAll: ' comment: '; print: self comment.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
priority
	^ self propertyAt: #priority ifAbsent: [ self class defaultPriority ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
priority: aNumber
	self propertyAt: #priority put: aNumber.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
readonly	
	^ self propertyAt: #readonly ifAbsent: [ self class defaultReadonly ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
readonly: aBoolean	
	self propertyAt: #readonly put: aBoolean.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
required	
	^ self propertyAt: #required ifAbsent: [ self class defaultRequired ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
required: aBoolean	
	self propertyAt: #required put: aBoolean.! !

!MADescription methodsFor: 'accessing-strings' stamp: 'lr 10/20/2005 00:13'!
stringReader
	^ self propertyAt: #stringReader ifAbsent: [ self class defaultStringReader ].! !

!MADescription methodsFor: 'accessing-strings' stamp: 'lr 10/20/2005 00:13'!
stringReader: aClass
	self propertyAt: #stringReader put: aClass.! !

!MADescription methodsFor: 'private' stamp: 'lr 10/28/2005 17:24'!
stringToCollection: aString
	^ Array streamContents: [ :stream |
		aString readStream in: [ :input |
			[ input atEnd ] whileFalse: [
				stream nextPut: (input upTo: Character cr).
				input peek = Character lf 
					ifTrue: [ input next ] ] ] ].! !

!MADescription methodsFor: 'accessing-strings' stamp: 'lr 10/20/2005 00:13'!
stringWriter
	^ self propertyAt: #stringWriter ifAbsent: [ self class defaultStringWriter ].! !

!MADescription methodsFor: 'accessing-strings' stamp: 'lr 10/20/2005 00:14'!
stringWriter: aClass
	self propertyAt: #stringWriter put: aClass.! !

!MADescription methodsFor: 'strings' stamp: 'lr 10/20/2005 00:12'!
toString: anObject
	^ self toString: anObject writer: self stringWriter.! !

!MADescription methodsFor: 'strings' stamp: 'lr 10/20/2005 00:12'!
toString: anObject writer: aFormatter
	^ aFormatter write: anObject description: self.! !

!MADescription methodsFor: 'accessing-strings' stamp: 'lr 10/20/2005 00:14'!
undefined	
	| undefined |
	undefined := self propertyAt: #undefined ifAbsent: [ self class defaultUndefined ].
	^ undefined ifNil: [ self class defaultUndefined ].! !

!MADescription methodsFor: 'accessing-strings' stamp: 'lr 10/20/2005 00:14'!
undefined: aString
	self propertyAt: #undefined put: aString.! !

!MADescription methodsFor: 'validation' stamp: 'lr 10/27/2005 16:02'!
validateConditions: anObject
	" Validate anObject to satisfy all its custom conditions. "
	
	self conditions do: [ :each |
		(each key isSatisfiedBy: anObject)
			ifFalse: [ MAConditionError on: self explanation: each value ] ].! !

!MADescription methodsFor: 'validation' stamp: 'lr 10/27/2005 15:23'!
validateKind: anObject
	"  Validate anObject to be of the right kind. "
	
	(anObject isKindOf: self kind)
		ifFalse: [ MAKindError on: self ].! !

!MADescription methodsFor: 'validation' stamp: 'lr 10/27/2005 16:29'!
validateRequired: anObject
	" Validate anObject not to be nil if it is required. "
	
	(self isRequired and: [ anObject isNil ])
		ifTrue: [ MARequiredError on: self ].
	! !

!MADescription methodsFor: 'validation' stamp: 'lr 10/27/2005 16:09'!
validateSpecific: anObject
	" Validate anObject to satisfy all its description specific validation rules. Subclasses mostly want to override this method. "! !

!MADescription methodsFor: 'validation' stamp: 'lr 10/27/2005 16:09'!
validate: anObject
	" Validate anObject in the context of the describing-receiver, raises an error in case of a problem. If anObject is nil and not required, most tests will be skipped. Do not override this message, instead have a look at #validateGeneric: what is usually a better place to define the behaviour your description requires. "
	
	self validateRequired: anObject.
	anObject isNil ifFalse: [
		self 
			validateKind: anObject;
			validateSpecific: anObject;
			validateConditions: anObject ].! !

!MADescription methodsFor: 'validation' stamp: 'lr 10/27/2005 18:00'!
validate: anObject description: aDescription
	[ aDescription validate: anObject ]
		on: MAValidationError
		do: [ :err | err setDescription: self; pass ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
visible	
	^ self propertyAt: #visible ifAbsent: [ self class defaultVisible ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
visible: aBoolean
	self propertyAt: #visible put: aBoolean.! !

!MADescription methodsFor: 'operators' stamp: 'lr 5/8/2005 20:30'!
, aDescription
	"Merge the receiver and aDescription to one composed description"

	^ self asContainer copy
		addAll: aDescription asContainer;
		yourself.! !

!MADescription methodsFor: 'operators' stamp: 'lr 5/8/2005 20:30'!
<= anObject
	"Answer whether the receiver should precede anObject in a priority container."
	
	^ self priority <= anObject priority.! !

!MADescription methodsFor: 'comparing' stamp: 'lr 7/7/2005 14:22'!
= anObject
	^ super = anObject
		and: [ self accessor = anObject accessor ].! !

MADescription subclass: #MAElementDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Description'!

MAElementDescription subclass: #MABooleanDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Description'!

!MABooleanDescription commentStamp: '<historical>' prior: 0!
I'm a simple description for booleans. Forms should display me as a checkbox or something similar.!

!MABooleanDescription class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MABooleanDescription class methodsFor: 'accessing' stamp: 'lr 10/29/2005 21:28'!
label
	^ 'Boolean'! !

!MABooleanDescription methodsFor: 'visiting' stamp: 'lr 10/29/2005 20:48'!
acceptMagritte: aVisitor
	aVisitor visitBooleanDescription: self.! !

!MABooleanDescription methodsFor: 'private' stamp: 'lr 5/8/2005 20:29'!
falseStrings
	^ #( 'false' 'f' 'no' 'n' '0' 'off' )! !

!MABooleanDescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
kind
	^ Boolean! !

!MABooleanDescription methodsFor: 'private' stamp: 'lr 5/8/2005 20:29'!
trueStrings
	^ #( 'true' 't' 'yes' 'y' '1' 'on' )! !

MAElementDescription subclass: #MAClassDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Description'!

!MAClassDescription class methodsFor: 'testing' stamp: 'lr 9/12/2005 16:52'!
isAbstract
	^ false! !

!MAClassDescription class methodsFor: 'accessing' stamp: 'lr 10/29/2005 21:28'!
label
	^ 'Class'! !

!MAClassDescription methodsFor: 'visiting' stamp: 'lr 10/29/2005 20:48'!
acceptMagritte: aVisitor
	aVisitor visitClassDescription: self.! !

!MAClassDescription methodsFor: 'accessing' stamp: 'lr 9/12/2005 16:51'!
kind
	^ Class! !

MAElementDescription subclass: #MAColorDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Description'!

!MAColorDescription commentStamp: '<historical>' prior: 0!
Use me if you want your user to choose a color.!

!MAColorDescription class methodsFor: 'testing' stamp: 'lr 5/9/2005 17:14'!
isAbstract
	^ false! !

!MAColorDescription class methodsFor: 'accessing' stamp: 'lr 10/29/2005 21:28'!
label
	^ 'Color'! !

!MAColorDescription methodsFor: 'visiting' stamp: 'lr 10/29/2005 20:48'!
acceptMagritte: aVisitor
	aVisitor visitColorDescription: self.! !

!MAColorDescription methodsFor: 'accessing' stamp: 'lr 5/9/2005 17:13'!
kind
	^ Color! !

!MAElementDescription methodsFor: 'visiting' stamp: 'lr 10/29/2005 20:48'!
acceptMagritte: aVisitor
	aVisitor visitElementDescription: self.! !

!MAElementDescription methodsFor: 'converting' stamp: 'lr 5/8/2005 20:31'!
asContainer
	^ MAContainer with: self.! !

!MAElementDescription methodsFor: 'accessing' stamp: 'lr 9/15/2005 10:31'!
default	
	^ self propertyAt: #default ifAbsent: [ self class defaultDefault ].! !

!MAElementDescription methodsFor: 'accessing' stamp: 'lr 9/15/2005 10:31'!
default: anObject
	self propertyAt: #default put: anObject.! !

MAElementDescription subclass: #MAFileDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Description'!

!MAFileDescription commentStamp: '<historical>' prior: 0!
If you want to ask your user for a file, just use me. I render a button for the user to browse his computer and select a file.!

!MAFileDescription class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MAFileDescription class methodsFor: 'accessing' stamp: 'lr 10/29/2005 21:28'!
label
	^ 'File'! !

!MAFileDescription methodsFor: 'visiting' stamp: 'lr 10/29/2005 20:48'!
acceptMagritte: aVisitor
	aVisitor visitFileDescription: self.! !

!MAFileDescription methodsFor: 'accessing' stamp: 'lr 8/10/2005 19:39'!
kind
	^ MAFileModel! !

MAElementDescription subclass: #MAMagnitudeDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Description'!

MAMagnitudeDescription subclass: #MADateDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Description'!

!MADateDescription class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MADateDescription class methodsFor: 'accessing' stamp: 'lr 10/29/2005 21:28'!
label
	^ 'Date'! !

!MADateDescription methodsFor: 'visiting' stamp: 'lr 10/29/2005 20:48'!
acceptMagritte: aVisitor
	aVisitor visitDateDescription: self.! !

!MADateDescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:30'!
kind
	^ Date! !

MAMagnitudeDescription subclass: #MADurationDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Description'!

!MADurationDescription class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MADurationDescription class methodsFor: 'accessing' stamp: 'lr 10/29/2005 21:29'!
label
	^ 'Duration'! !

!MADurationDescription methodsFor: 'visiting' stamp: 'lr 10/29/2005 20:48'!
acceptMagritte: aVisitor
	aVisitor visitDurationDescription: self.! !

!MADurationDescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:30'!
kind
	^ Duration! !

!MAMagnitudeDescription class methodsFor: 'accessing-defaults' stamp: 'lr 10/19/2005 20:10'!
defaultMax
	^ nil! !

!MAMagnitudeDescription class methodsFor: 'accessing-defaults' stamp: 'lr 10/19/2005 20:10'!
defaultMin
	^ nil! !

!MAMagnitudeDescription class methodsFor: 'accessing-description' stamp: 'lr 10/19/2005 20:10'!
descriptionMax
	^ self selector: #max label: 'Maximum' priority: 410.! !

!MAMagnitudeDescription class methodsFor: 'accessing-description' stamp: 'lr 10/19/2005 20:10'!
descriptionMin
	^ self selector: #min label: 'Min' priority: 400.! !

!MAMagnitudeDescription methodsFor: 'visiting' stamp: 'lr 10/29/2005 20:48'!
acceptMagritte: aVisitor
	aVisitor visitMagnitudeDescription: self.! !

!MAMagnitudeDescription methodsFor: 'testing' stamp: 'lr 10/27/2005 15:27'!
isWithinRange: anObject
	^ (self min isNil or: [ self min <= anObject ]) 
		and: [ self max isNil or: [ self max >= anObject ] ].! !

!MAMagnitudeDescription methodsFor: 'accessing' stamp: 'lr 10/19/2005 20:09'!
max
	^ self propertyAt: #max ifAbsent: [ self class defaultMax ].! !

!MAMagnitudeDescription methodsFor: 'accessing' stamp: 'lr 10/19/2005 20:09'!
max: aMagnitudeOrNil
	^ self propertyAt: #max put: aMagnitudeOrNil.! !

!MAMagnitudeDescription methodsFor: 'accessing' stamp: 'lr 10/19/2005 20:09'!
min
	^ self propertyAt: #min ifAbsent: [ self class defaultMin ].! !

!MAMagnitudeDescription methodsFor: 'accessing' stamp: 'lr 10/19/2005 20:10'!
min: aMagnitudeOrNil
	^ self propertyAt: #min put: aMagnitudeOrNil.! !

!MAMagnitudeDescription methodsFor: 'conveniance' stamp: 'lr 10/19/2005 20:15'!
min: aMinimumObject max: aMaximumObject
	self min: aMinimumObject; max: aMaximumObject.! !

!MAMagnitudeDescription methodsFor: 'validation' stamp: 'lr 10/27/2005 16:10'!
validateSpecific: anObject
	super validateSpecific: anObject.
	(self isWithinRange: anObject)
		ifFalse: [ MARangeError on: self ].! !

MAMagnitudeDescription subclass: #MANumberDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Description'!

!MANumberDescription commentStamp: 'dc 8/24/2005 15:43' prior: 0!
Use me if you want to ask numbers to your customer.

The range of accepted values is not limited. You can restrict it using:

- #min:  set a minimum value for the range
- #max: set the maximum value accepted
- #min:max: set a minimum and a maximum
- #beInteger restrict to integer values
- #bePositive restrict to positive values (>= 0)
!

!MANumberDescription class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MANumberDescription class methodsFor: 'accessing' stamp: 'lr 10/29/2005 21:29'!
label
	^ 'Number'! !

!MANumberDescription methodsFor: 'visiting' stamp: 'lr 10/29/2005 20:48'!
acceptMagritte: aVisitor
	aVisitor visitNumberDescription: self.! !

!MANumberDescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
kind
	^ Number! !

MAMagnitudeDescription subclass: #MATimeDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Description'!

!MATimeDescription class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:34'!
isAbstract
	^ false! !

!MATimeDescription class methodsFor: 'accessing' stamp: 'lr 10/29/2005 21:44'!
label
	^ 'Time'! !

!MATimeDescription methodsFor: 'visiting' stamp: 'lr 10/29/2005 20:48'!
acceptMagritte: aVisitor
	aVisitor visitTimeDescription: self.! !

!MATimeDescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:33'!
kind
	^ Time! !

MAMagnitudeDescription subclass: #MATimeStampDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Description'!

!MATimeStampDescription class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:34'!
isAbstract
	^ false! !

!MATimeStampDescription class methodsFor: 'accessing' stamp: 'lr 10/29/2005 21:45'!
label
	^ 'Timestamp'! !

!MATimeStampDescription methodsFor: 'visiting' stamp: 'lr 10/29/2005 20:48'!
acceptMagritte: aVisitor
	aVisitor visitTimeStampDescription: self.! !

!MATimeStampDescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:33'!
kind
	^ TimeStamp! !

MAElementDescription subclass: #MAReferenceDescription
	instanceVariableNames: 'reference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Description'!

MAReferenceDescription subclass: #MAOptionDescription
	instanceVariableNames: 'options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Description'!

MAOptionDescription subclass: #MAMultipleOptionDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Description'!

!MAMultipleOptionDescription class methodsFor: 'accessing-defaults' stamp: 'lr 10/29/2005 09:10'!
defaultUnique
	^ true! !

!MAMultipleOptionDescription class methodsFor: 'accessing-description' stamp: 'lr 10/29/2005 09:10'!
descriptionUnique
	^ MABooleanDescription selector: #unique label: 'Unique' priority: 250 default: self defaultUnique.! !

!MAMultipleOptionDescription class methodsFor: 'testing' stamp: 'lr 9/13/2005 09:31'!
isAbstract
	^ false! !

!MAMultipleOptionDescription class methodsFor: 'accessing' stamp: 'lr 10/29/2005 21:46'!
label
	^ 'Multiple-Option'! !

!MAMultipleOptionDescription methodsFor: 'visiting' stamp: 'lr 10/29/2005 20:48'!
acceptMagritte: aVisitor
	aVisitor visitMultipleOptionDescription: self.! !

!MAMultipleOptionDescription methodsFor: 'testing' stamp: 'lr 10/29/2005 09:11'!
isUnique
	^ self unique.! !

!MAMultipleOptionDescription methodsFor: 'accessing' stamp: 'lr 10/30/2005 13:38'!
kind
	^ Collection! !

!MAMultipleOptionDescription methodsFor: 'accessing-properties' stamp: 'lr 10/29/2005 09:09'!
unique
	^ self propertyAt: #unique ifAbsent: [ self class defaultUnique ].! !

!MAMultipleOptionDescription methodsFor: 'accessing-properties' stamp: 'lr 10/29/2005 09:09'!
unique: aBoolean
	self propertyAt: #unique put: aBoolean.! !

!MAMultipleOptionDescription methodsFor: 'validating' stamp: 'lr 10/27/2005 17:29'!
validateKind: anObject
	super validateKind: anObject.
	(anObject allSatisfy: [ :each | self options includes: each ])
		ifFalse: [ MAKindError on: self ].! !

!MAMultipleOptionDescription methodsFor: 'validating' stamp: 'lr 10/27/2005 17:30'!
validateRequired: anObject
	super validateRequired: anObject.
	(self isRequired and: [ anObject isCollection ] and: [ anObject isEmpty ])
		ifTrue: [ MARequiredError on: self ].! !

!MAMultipleOptionDescription methodsFor: 'validating' stamp: 'lr 10/27/2005 16:31'!
validateSpecific: anObject
	super validateSpecific: anObject.
	anObject do: [ :each | self validate: each description: self reference ].! !

!MAOptionDescription class methodsFor: 'accessing-defaults' stamp: 'lr 9/14/2005 22:38'!
defaultOptions
	^ OrderedCollection new! !

!MAOptionDescription class methodsFor: 'accessing-defaults' stamp: 'lr 10/29/2005 09:10'!
defaultSorted
	^ false! !

!MAOptionDescription class methodsFor: 'accessing-description' stamp: 'lr 10/29/2005 09:13'!
descriptionDefault
	^ nil! !

!MAOptionDescription class methodsFor: 'accessing-description' stamp: 'lr 10/29/2005 09:07'!
descriptionOptions
	^ MATextDescription selector: #optionsTextual label: 'Options' priority: 410 default: self defaultOptions.! !

!MAOptionDescription class methodsFor: 'accessing-description' stamp: 'lr 10/19/2005 19:40'!
descriptionSorted
	^ MABooleanDescription selector: #sorted label: 'Sorted' priority: 240 default: self defaultSorted.! !

!MAOptionDescription methodsFor: 'visiting' stamp: 'lr 10/29/2005 20:48'!
acceptMagritte: aVisitor
	aVisitor visitOptionDescription: self.! !

!MAOptionDescription methodsFor: 'accessing-dynamic' stamp: 'lr 9/30/2005 20:48'!
allOptions
	| list |
	list := self options copy asArray.
	self isSorted ifTrue: [ 
		list sort: [ :a :b | 
			(self reference toString: a) 
				caseInsensitiveLessOrEqual: (self reference toString: b) ] ].
	^ list.! !

!MAOptionDescription methodsFor: 'actions' stamp: 'lr 9/13/2005 09:29'!
beSorted
	self sorted: true.! !

!MAOptionDescription methodsFor: 'actions' stamp: 'lr 9/15/2005 11:42'!
beUnsorted
	self sorted: false.! !

!MAOptionDescription methodsFor: 'testing' stamp: 'lr 9/13/2005 07:22'!
isSorted
	^ self sorted.! !

!MAOptionDescription methodsFor: 'accessing' stamp: 'lr 9/14/2005 22:38'!
options
	^ options ifNil: [ options := self class defaultOptions ].! !

!MAOptionDescription methodsFor: 'accessing-textual' stamp: 'lr 10/29/2005 09:06'!
optionsTextual
	^ self collectionToString: self options.! !

!MAOptionDescription methodsFor: 'accessing-textual' stamp: 'lr 10/29/2005 09:06'!
optionsTextual: aString
	^ self options: (self stringToCollection: aString).! !

!MAOptionDescription methodsFor: 'accessing' stamp: 'lr 9/13/2005 07:29'!
options: anArray
	options := anArray! !

!MAOptionDescription methodsFor: 'copying' stamp: 'lr 9/12/2005 21:39'!
postCopy
	super postCopy.
	self options: self options copy.! !

!MAOptionDescription methodsFor: 'accessing-properties' stamp: 'lr 9/12/2005 21:40'!
sorted
	^ self propertyAt: #sorted ifAbsent: [ self class defaultSorted ].! !

!MAOptionDescription methodsFor: 'accessing-properties' stamp: 'lr 9/12/2005 21:40'!
sorted: aBoolean
	^ self propertyAt: #sorted put: aBoolean.! !

MAOptionDescription subclass: #MASingleOptionDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Description'!

!MASingleOptionDescription class methodsFor: 'testing' stamp: 'lr 9/13/2005 09:31'!
isAbstract
	^ false! !

!MASingleOptionDescription class methodsFor: 'accessing' stamp: 'lr 10/29/2005 21:46'!
label
	^ 'Single-Option'! !

!MASingleOptionDescription methodsFor: 'visiting' stamp: 'lr 10/29/2005 20:48'!
acceptMagritte: aVisitor
	aVisitor visitSingleOptionDescription: self.! !

!MASingleOptionDescription methodsFor: 'accessing' stamp: 'lr 9/30/2005 20:48'!
allOptions
	^ self isRequired
		ifTrue: [ super allOptions ] 
		ifFalse: [ super allOptions copyWithFirst: nil ].
! !

!MASingleOptionDescription methodsFor: 'validating' stamp: 'lr 10/27/2005 16:33'!
validateKind: anObject
	super validateKind: anObject.
	(self options includes: anObject)
		ifFalse: [ MAKindError on: self ].! !

!MASingleOptionDescription methodsFor: 'validating' stamp: 'lr 10/30/2005 12:51'!
validateSpecific: anObject
	super validateSpecific: anObject.
	self validate: anObject description: self reference.! !

!MAReferenceDescription class methodsFor: 'accessing-defaults' stamp: 'lr 9/15/2005 11:47'!
defaultReference
	^ MAStringDescription new.! !

!MAReferenceDescription class methodsFor: 'accessing-description' stamp: 'lr 10/30/2005 13:08'!
descriptionReference
	^ (MAOneToOneRelationDescription selector: #reference label: 'Description' priority: 400)
		classes: (MADynamicObject on: [ MADescription withAllConcreteClasses ]);
		beRequired;
		yourself.! !

!MAReferenceDescription methodsFor: 'visiting' stamp: 'lr 10/29/2005 20:48'!
acceptMagritte: aVisitor
	aVisitor visitReferenceDescription: self.! !

!MAReferenceDescription methodsFor: 'copying' stamp: 'lr 9/12/2005 16:44'!
postCopy
	super postCopy.
	self reference: self reference copy.! !

!MAReferenceDescription methodsFor: 'accessing' stamp: 'lr 9/15/2005 11:47'!
reference
	^ reference ifNil: [ reference := self class defaultReference ].! !

!MAReferenceDescription methodsFor: 'accessing' stamp: 'lr 9/12/2005 16:42'!
reference: aDescription
	reference := aDescription! !

MAReferenceDescription subclass: #MARelationDescription
	instanceVariableNames: 'classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Description'!

MARelationDescription subclass: #MAOneToManyRelationDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Description'!

!MAOneToManyRelationDescription class methodsFor: 'testing' stamp: 'lr 10/19/2005 22:32'!
isAbstract
	^ false! !

!MAOneToManyRelationDescription class methodsFor: 'accessing' stamp: 'lr 10/30/2005 13:02'!
label
	^ '1:m Relation'! !

!MAOneToManyRelationDescription methodsFor: 'visiting' stamp: 'lr 10/29/2005 20:48'!
acceptMagritte: aVisitor
	aVisitor visitOneToManyRelationDescription: self.! !

!MAOneToManyRelationDescription methodsFor: 'accessing' stamp: 'lr 10/27/2005 16:26'!
kind
	^ Collection! !

!MAOneToManyRelationDescription methodsFor: 'validating' stamp: 'lr 10/30/2005 13:26'!
validateKind: anObject
	super validateKind: anObject.
	anObject do: [ :object |
		(self classes anySatisfy: [ :class | object species = class ])
			ifFalse: [ MAKindError on: self ] ].! !

!MAOneToManyRelationDescription methodsFor: 'validating' stamp: 'lr 10/27/2005 18:02'!
validateRequired: anObject
	super validateRequired: anObject.
	(self isRequired and: [ anObject isCollection ] and: [ anObject isEmpty ])
		ifTrue: [ MARequiredError on: self ].! !

!MAOneToManyRelationDescription methodsFor: 'validating' stamp: 'lr 11/7/2005 09:34'!
validateSpecific: anObject
	super validateSpecific: anObject.
	anObject do: [ :each | self validate: each description: each description ].! !

MARelationDescription subclass: #MAOneToOneRelationDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Description'!

!MAOneToOneRelationDescription class methodsFor: 'testing' stamp: 'lr 10/19/2005 22:33'!
isAbstract
	^ false! !

!MAOneToOneRelationDescription class methodsFor: 'accessing' stamp: 'lr 10/30/2005 13:02'!
label
	^ '1:1 Relation'! !

!MAOneToOneRelationDescription methodsFor: 'visiting' stamp: 'lr 10/29/2005 20:48'!
acceptMagritte: aVisitor
	aVisitor visitOneToOneRelationDescription: self.! !

!MAOneToOneRelationDescription methodsFor: 'validating' stamp: 'lr 10/30/2005 13:27'!
validateKind: anObject
	super validateKind: anObject.
	(self classes anySatisfy: [ :class | anObject species = class ])
		ifFalse: [ MAKindError on: self ].! !

!MAOneToOneRelationDescription methodsFor: 'validating' stamp: 'lr 11/7/2005 09:34'!
validateSpecific: anObject
	super validateSpecific: anObject.
	self validate: anObject description: anObject description.! !

!MARelationDescription class methodsFor: 'accessing-defaults' stamp: 'lr 10/27/2005 17:00'!
defaultClasses
	^ Set new.! !

!MARelationDescription class methodsFor: 'accessing-defaults' stamp: 'lr 10/29/2005 20:56'!
defaultReference
	^ nil! !

!MARelationDescription class methodsFor: 'accessing-description' stamp: 'lr 10/30/2005 13:09'!
descriptionClasses
	^ (MAMultipleOptionDescription selector: #classes label: 'Classes' priority: 400)
		options: (MADynamicObject on: [ Smalltalk allClasses ]);
		reference: MAClassDescription new;
		yourself.! !

!MARelationDescription class methodsFor: 'accessing-description' stamp: 'lr 10/30/2005 13:07'!
descriptionReference
	^ super descriptionReference
		classes: (MADynamicObject on: [ MAContainer withAllConcreteClasses ]);
		beOptional;
		yourself.! !

!MARelationDescription methodsFor: 'visiting' stamp: 'lr 10/29/2005 20:48'!
acceptMagritte: aVisitor
	aVisitor visitRelationDescription: self.! !

!MARelationDescription methodsFor: 'accessing-dynamic' stamp: 'lr 10/29/2005 21:58'!
allClasses
	^ (Array withAll: self classes)
		sort: [ :a :b | a label caseInsensitiveLessOrEqual: b label ];
		yourself.! !

!MARelationDescription methodsFor: 'accessing' stamp: 'lr 10/27/2005 16:22'!
classes
	^ classes ifNil: [ classes := self class defaultClasses ].! !

!MARelationDescription methodsFor: 'accessing' stamp: 'lr 10/27/2005 16:23'!
classes: aCollection
	classes := aCollection! !

!MARelationDescription methodsFor: 'accessing-dynamic' stamp: 'lr 10/30/2005 13:05'!
commonClass
	"Answer a common superclass of the classes of the receiver. The algorithm is implemented to be as efficient as possible, the inner loop will be only execute the first few iterations."

	| current |
	self classes isEmpty 
		ifTrue: [ ^ self class defaultContainer ].
	current := self classes anyOne.
	self classes do: [ :each |
		[ each includesBehavior: current ] 
			whileFalse: [ current := current superclass ] ].
	^ current.! !

!MARelationDescription methodsFor: 'copying' stamp: 'lr 10/27/2005 16:23'!
postCopy
	super postCopy.
	self classes: self classes copy.! !

!MARelationDescription methodsFor: 'accessing-dynamic' stamp: 'lr 10/30/2005 13:24'!
reference
	"The reference within a MARelationDescription is calculated automatically from all the classes of the receiver, if set to nil. By setting the reference to a MAContainer instance it is possible to customize the reference description."

	^ super reference ifNil: [ self commonClass description ].! !

MAReferenceDescription subclass: #MATableDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Description'!

!MATableDescription class methodsFor: 'accessing-defaults' stamp: 'lr 10/19/2005 19:39'!
defaultColumnLabels
	^ OrderedCollection with: 'a' with: 'b' with: 'c'.! !

!MATableDescription class methodsFor: 'accessing-defaults' stamp: 'lr 10/10/2005 09:38'!
defaultRowLabels
	^ OrderedCollection with: '1' with: '2' with: '3'.! !

!MATableDescription class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:34'!
descriptionColumnLabels
	^ MATextDescription selector: #columnLabelsTextual label: 'Column Labels' priority: 250.! !

!MATableDescription class methodsFor: 'accessing-description' stamp: 'lr 10/28/2005 17:26'!
descriptionDefault
	^ nil! !

!MATableDescription class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:34'!
descriptionRequired
	^ nil! !

!MATableDescription class methodsFor: 'accessing-description' stamp: 'lr 10/28/2005 17:16'!
descriptionRowLabels
	^ MATextDescription selector: #rowLabelsTextual label: 'Row Labels' priority: 250.! !

!MATableDescription class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:34'!
isAbstract
	^ false! !

!MATableDescription class methodsFor: 'accessing' stamp: 'lr 10/29/2005 21:46'!
label
	^ 'Table'! !

!MATableDescription methodsFor: 'visiting' stamp: 'lr 10/29/2005 20:48'!
acceptMagritte: aVisitor
	aVisitor visitTableDescription: self.! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 10/3/2005 09:57'!
columnCount
	^ self columnLabels size.! !

!MATableDescription methodsFor: 'accessing-properties' stamp: 'lr 10/3/2005 09:58'!
columnLabels
	^ self propertyAt: #columnLabels ifAbsent: [ self class defaultColumnLabels ].! !

!MATableDescription methodsFor: 'accessing-textual' stamp: 'lr 10/28/2005 17:24'!
columnLabelsTextual
	^ self collectionToString: self columnLabels.! !

!MATableDescription methodsFor: 'accessing-textual' stamp: 'lr 10/28/2005 17:25'!
columnLabelsTextual: aString
	self columnLabels: (self stringToCollection: aString).! !

!MATableDescription methodsFor: 'accessing-properties' stamp: 'lr 10/3/2005 09:59'!
columnLabels: aCollection
	self propertyAt: #columnLabels put: aCollection.! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 10/10/2005 09:31'!
kind
	^ MATableModel ! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 10/3/2005 09:57'!
rowCount
	^ self rowLabels size.! !

!MATableDescription methodsFor: 'accessing-properties' stamp: 'lr 10/3/2005 09:58'!
rowLabels
	^ self propertyAt: #rowLabels ifAbsent: [ self class defaultRowLabels ].! !

!MATableDescription methodsFor: 'accessing-textual' stamp: 'lr 10/28/2005 17:25'!
rowLabelsTextual
	^ self collectionToString: self rowLabels.! !

!MATableDescription methodsFor: 'accessing-textual' stamp: 'lr 10/28/2005 17:25'!
rowLabelsTextual: aString
	self rowLabels: (self stringToCollection: aString).! !

!MATableDescription methodsFor: 'accessing-properties' stamp: 'lr 10/3/2005 09:59'!
rowLabels: aCollection
	self propertyAt: #rowLabels put: aCollection.! !

!MATableDescription methodsFor: 'validation' stamp: 'lr 10/27/2005 16:10'!
validateSpecific: anObject
	super validateSpecific: anObject.
	(anObject rowCount ~= self rowCount
		or: [ anObject columnCount ~= self columnCount ])
			ifTrue: [ MAKindError on: self ].
	anObject contents do: [ :each |
		self validate: each description: self reference ].! !

MAReferenceDescription subclass: #MATokenDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Description'!

!MATokenDescription class methodsFor: 'testing' stamp: 'lr 8/11/2005 09:32'!
isAbstract
	^ false! !

!MATokenDescription class methodsFor: 'accessing' stamp: 'lr 10/29/2005 21:46'!
label
	^ 'Token'! !

!MATokenDescription methodsFor: 'visiting' stamp: 'lr 10/29/2005 20:48'!
acceptMagritte: aVisitor
	aVisitor visitTokenDescription: self.! !

!MATokenDescription methodsFor: 'accessing' stamp: 'lr 8/13/2005 11:37'!
kind
	^ Array! !

MAElementDescription subclass: #MAStringDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Description'!

!MAStringDescription commentStamp: '<historical>' prior: 0!
I'm a very common description used to display strings or ask strings to the user. I provide interface to type one lined strings. Use MATextDescription if you want to allow multiple lines.!

MAStringDescription subclass: #MAPasswordDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Description'!

!MAPasswordDescription commentStamp: '<historical>' prior: 0!
I'm basically a string, but when the user type something, stars '*' are printed instead of the characters he entered.!

!MAPasswordDescription class methodsFor: 'accessing' stamp: 'lr 10/29/2005 21:45'!
label
	^ 'Password'! !

!MAPasswordDescription methodsFor: 'visiting' stamp: 'lr 10/29/2005 20:48'!
acceptMagritte: aVisitor
	aVisitor visitPasswordDescription: self.! !

!MAPasswordDescription methodsFor: 'testing' stamp: 'lr 5/8/2005 20:31'!
isObfuscated: anObject
	^ anObject notNil
		and: [ anObject isString ] 
		and: [ anObject allSatisfy: [ :each | each = $* ] ].! !

!MAPasswordDescription methodsFor: 'operators' stamp: 'lr 5/8/2005 20:31'!
obfuscated: anObject
	^ String new: (self toString: anObject) size withAll: $*.! !

!MAStringDescription class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:34'!
isAbstract
	^ false! !

!MAStringDescription class methodsFor: 'accessing' stamp: 'lr 10/29/2005 21:45'!
label
	^ 'String'! !

!MAStringDescription methodsFor: 'visiting' stamp: 'lr 10/29/2005 20:48'!
acceptMagritte: aVisitor
	aVisitor visitStringDescription: self.! !

!MAStringDescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
kind
	^ String! !

MAStringDescription subclass: #MASymbolDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Description'!

!MASymbolDescription class methodsFor: 'accessing' stamp: 'lr 10/29/2005 21:45'!
label
	^ 'Symbol'! !

!MASymbolDescription methodsFor: 'visiting' stamp: 'lr 10/29/2005 20:48'!
acceptMagritte: aVisitor
	aVisitor visitSymbolDescription: self.! !

!MASymbolDescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
kind
	^ Symbol! !

MAStringDescription subclass: #MATextDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Description'!

!MATextDescription commentStamp: '<historical>' prior: 0!
I'm a string for multi line input. If you just want to ask the user for just a line of text, use MAStringDescription.!

!MATextDescription class methodsFor: 'accessing' stamp: 'lr 10/29/2005 21:45'!
label
	^ 'Text'! !

!MATextDescription methodsFor: 'visiting' stamp: 'lr 10/29/2005 20:48'!
acceptMagritte: aVisitor
	aVisitor visitTextDescription: self.! !

MAObject subclass: #MAMemento
	instanceVariableNames: 'model description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Memento'!

MAMemento subclass: #MACachedMemento
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Memento'!

!MACachedMemento class methodsFor: 'testing' stamp: 'lr 9/20/2005 21:00'!
isAbstract
	^ false! !

!MACachedMemento methodsFor: 'accessing' stamp: 'lr 9/20/2005 21:32'!
cache
	^ cache! !

!MACachedMemento methodsFor: 'actions' stamp: 'lr 10/19/2005 00:00'!
commit
	super commit.
	self push: self cache.
	self reset.! !

!MACachedMemento methodsFor: 'testing' stamp: 'lr 10/19/2005 21:53'!
hasChanged
	^ self cache ~= self pullRaw.! !

!MACachedMemento methodsFor: 'private' stamp: 'lr 9/20/2005 20:37'!
readUsing: aDescription
	^ self cache at: aDescription.! !

!MACachedMemento methodsFor: 'actions' stamp: 'lr 10/19/2005 21:52'!
reset
	super reset.
	self setCache: self pull.! !

!MACachedMemento methodsFor: 'initialization' stamp: 'lr 9/20/2005 20:13'!
setCache: aDictionary
	cache := aDictionary! !

!MACachedMemento methodsFor: 'private' stamp: 'lr 9/20/2005 20:08'!
write: anObject using: aDescription
	self cache at: aDescription put: anObject.! !

MACachedMemento subclass: #MACheckedMemento
	instanceVariableNames: 'original'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Memento'!

!MACheckedMemento methodsFor: 'testing' stamp: 'lr 10/19/2005 21:53'!
hasConflict
	^ self hasChanged and: [ self original ~= self pullRaw ].! !

!MACheckedMemento methodsFor: 'accessing' stamp: 'lr 9/20/2005 22:06'!
original
	^ original! !

!MACheckedMemento methodsFor: 'actions' stamp: 'lr 10/19/2005 21:53'!
reset
	super reset.
	self setOriginal: self pullRaw.! !

!MACheckedMemento methodsFor: 'initialization' stamp: 'lr 9/20/2005 20:35'!
setOriginal: aDictionary
	original := aDictionary! !

!MACheckedMemento methodsFor: 'actions' stamp: 'lr 10/19/2005 21:21'!
validate
	self hasConflict
		ifTrue: [ MAConflictError on: self description ].
	super validate.! !

!MAMemento class methodsFor: 'instance creation' stamp: 'lr 9/20/2005 20:03'!
model: aModel
	^ self model: aModel description: aModel description.! !

!MAMemento class methodsFor: 'instance creation' stamp: 'lr 9/21/2005 07:22'!
model: aModel description: aDescription
	^ self new
		setModel: aModel;
		setDescription: aDescription;
		reset; yourself.! !

!MAMemento methodsFor: 'actions' stamp: 'lr 9/20/2005 20:09'!
commit
	"Commit the receiver into the model."! !

!MAMemento methodsFor: 'accessing' stamp: 'lr 9/20/2005 19:30'!
description
	^ description! !

!MAMemento methodsFor: 'accessing' stamp: 'lr 9/19/2005 20:00'!
model
	^ model! !

!MAMemento methodsFor: 'printing' stamp: 'lr 9/20/2005 20:36'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' model: '; print: self model.! !

!MAMemento methodsFor: 'private' stamp: 'lr 10/25/2005 23:53'!
pull
	"Utitlity method to pull the model into a dictionary mapping descriptions to values. nil values are replaced with the default ones of the model."
	
	| result |
	result := self pullRaw.
	result keysAndValuesDo: [ :key :value |
		value isNil
			ifTrue: [ result at: key put: key default yourself ] ].
	^ result.! !

!MAMemento methodsFor: 'private' stamp: 'lr 10/25/2005 23:53'!
pullRaw
	| result |
	result := Dictionary new.
	self description do: [ :each |
		result at: each put: (self model 
			readUsing: each) ].
	^ result.! !

!MAMemento methodsFor: 'private' stamp: 'lr 10/19/2005 21:47'!
push: aDictionary
	"Utitlity method to push a dictionary mapping descriptions to values into the model."

	aDictionary keysAndValuesDo: [ :key :value |
		key isReadonly ifFalse: [
			self model 
				write: value 
				using: key ] ].! !

!MAMemento methodsFor: 'actions' stamp: 'lr 9/20/2005 20:36'!
reset
	"Reset the memento from the model."! !

!MAMemento methodsFor: 'initialization' stamp: 'lr 9/19/2005 21:09'!
setDescription: aDescription
	description := aDescription! !

!MAMemento methodsFor: 'initialization' stamp: 'lr 9/19/2005 20:12'!
setModel: aModel
	model := aModel! !

!MAMemento methodsFor: 'actions' stamp: 'lr 9/20/2005 20:38'!
validate
	"Check if the value is valid within the model. In case of problems an exception is raised."
	
	self description validate: self.! !

MAMemento subclass: #MAStraitMemento
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Memento'!

!MAStraitMemento commentStamp: 'lr 9/22/2005 10:51' prior: 0!
The strait-memento forwards read- and write-access directly to the model.!

!MAStraitMemento class methodsFor: 'testing' stamp: 'lr 9/20/2005 21:00'!
isAbstract
	^ false! !

!MAStraitMemento methodsFor: 'private' stamp: 'lr 9/22/2005 10:50'!
readUsing: aDescription
	^ (self model readUsing: aDescription) 
		ifNil: [ aDescription default ].! !

!MAStraitMemento methodsFor: 'private' stamp: 'lr 9/20/2005 21:49'!
write: anObject using: aDescription
	self model write: anObject using: aDescription.! !

!MAObject class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ true! !

!MAObject class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
new
	"Create a new instance of the receiving class and checks if it is concrete."

	self isAbstract
		ifTrue: [ self error: self name , ' is abstract.' ].
	^ super new.! !

!MAObject class methodsFor: 'reflection' stamp: 'dc 8/15/2005 16:34'!
withAllConcreteClasses
	^ Array streamContents: [ :stream |
		self withAllConcreteClassesDo: [ :each |
			stream nextPut: each ] ].! !

!MAObject class methodsFor: 'reflection' stamp: 'dc 8/15/2005 16:33'!
withAllConcreteClassesDo: aBlock
	self withAllSubclassesDo: [ :each |
		each isAbstract ifFalse: [ 
			aBlock value: each ] ].! !

!MAObject methodsFor: 'visiting' stamp: 'lr 5/8/2005 20:31'!
acceptMagritte: aVisitor! !

!MAObject methodsFor: 'private' stamp: 'lr 10/20/2005 12:03'!
errorPropertyNotFound: aSelector
	self error: 'Property ' , aSelector , ' not found.'.! !

!MAObject methodsFor: 'comparing' stamp: 'lr 7/7/2005 13:26'!
hash
	^ self species hash.! !

!MAObject methodsFor: 'testing' stamp: 'lr 7/7/2005 14:39'!
hasProperty: aKey
	^ self properties includesKey: aKey.! !

!MAObject methodsFor: 'copying' stamp: 'lr 5/8/2005 20:31'!
postCopy
	super postCopy.
	properties := properties copy.! !

!MAObject methodsFor: 'accessing' stamp: 'lr 7/7/2005 13:23'!
properties
	^ properties ifNil: [ properties := Dictionary new ].! !

!MAObject methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
propertyAt: aKey
	^ self propertyAt: aKey ifAbsent: [ self errorPropertyNotFound: aKey ].! !

!MAObject methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
propertyAt: aKey ifAbsentPut: aBlock
	^ self properties at: aKey ifAbsentPut: aBlock.! !

!MAObject methodsFor: 'accessing' stamp: 'lr 7/7/2005 13:23'!
propertyAt: aKey ifAbsent: aBlock
	^ self properties at: aKey ifAbsent: aBlock.! !

!MAObject methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
propertyAt: aKey put: aValue
	^ self properties at: aKey put: aValue.! !

!MAObject methodsFor: 'comparing' stamp: 'lr 7/7/2005 13:25'!
= anObject
	^ self species = anObject species.! !

MAObject subclass: #MARelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Relation'!

!MARelation commentStamp: '<historical>' prior: 0!
I represent an immutable relation. Users usually want to check if the relation I am representing is satisfied by sending the message #isSatisfiedBy:!

MARelation subclass: #MABasicRelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Relation'!

MABasicRelation subclass: #MAConstantRelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Relation'!

!MAConstantRelation methodsFor: 'testing' stamp: 'lr 10/27/2005 14:42'!
isConstant
	^ true! !

MAConstantRelation subclass: #MAFalseRelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Relation'!

!MAFalseRelation class methodsFor: 'testing' stamp: 'lr 10/27/2005 14:11'!
isAbstract
	^ false! !

!MAFalseRelation methodsFor: 'testing' stamp: 'lr 10/27/2005 14:10'!
isSatisfiedBy: anObject
	^ false! !

!MAFalseRelation methodsFor: 'operators' stamp: 'lr 10/27/2005 14:36'!
not
	^ MATrueRelation new.! !

!MAFalseRelation methodsFor: 'operators' stamp: 'lr 10/27/2005 14:34'!
& aRelation
	^ self! !

!MAFalseRelation methodsFor: 'operators' stamp: 'lr 10/27/2005 14:34'!
| aRelation
	^ aRelation! !

MAConstantRelation subclass: #MATrueRelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Relation'!

!MATrueRelation class methodsFor: 'testing' stamp: 'lr 10/27/2005 14:11'!
isAbstract
	^ false! !

!MATrueRelation methodsFor: 'testing' stamp: 'lr 10/27/2005 14:11'!
isSatisfiedBy: anObject
	^ true! !

!MATrueRelation methodsFor: 'operators' stamp: 'lr 10/27/2005 14:36'!
not
	^ MAFalseRelation new.! !

!MATrueRelation methodsFor: 'operators' stamp: 'lr 10/27/2005 14:35'!
& aRelation
	^ aRelation! !

!MATrueRelation methodsFor: 'operators' stamp: 'lr 10/27/2005 14:35'!
| aRelation
	^ self! !

MABasicRelation subclass: #MASelectorRelation
	instanceVariableNames: 'selector arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Relation'!

MASelectorRelation subclass: #MAAccessorRelation
	instanceVariableNames: 'accessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Relation'!

!MAAccessorRelation methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
accessor
	^ accessor! !

!MAAccessorRelation methodsFor: 'testing' stamp: 'lr 8/10/2005 21:15'!
isSatisfiedBy: anObject
	| description |
	description := anObject description
		detect: [ :each | self accessor = each accessor ]
		ifNone: [ ^ false ].
	^ super isSatisfiedBy: (description accessor read: anObject).! !

!MAAccessorRelation methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:29'!
setAccessor: anAccessor
	accessor := anAccessor! !

MASelectorRelation subclass: #MAQueryRelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Relation'!

!MAQueryRelation methodsFor: 'testing' stamp: 'lr 5/8/2005 20:31'!
isSatisfiedBy: anObject
	^ super isSatisfiedBy: anObject query.! !

!MASelectorRelation class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:34'!
isAbstract
	^ false! !

!MASelectorRelation class methodsFor: 'conveniance' stamp: 'lr 5/8/2005 20:34'!
selector: aSelector
	^ self selector: aSelector arguments: Array new.! !

!MASelectorRelation class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:34'!
selector: aSelector arguments: aCollection
	^ self new
		setSelector: aSelector;
		setArguments: aCollection;
		yourself.! !

!MASelectorRelation class methodsFor: 'conveniance' stamp: 'lr 5/8/2005 20:34'!
selector: aSelector with: anObject
	^ self selector: aSelector arguments: (Array with: anObject).! !

!MASelectorRelation class methodsFor: 'conveniance' stamp: 'lr 5/8/2005 20:34'!
selector: aSelector with: aFirstObject with: aSecondObject
	^ self selector: aSelector arguments: (Array with: aFirstObject with: aSecondObject).! !

!MASelectorRelation methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
arguments
	^ arguments! !

!MASelectorRelation methodsFor: 'testing' stamp: 'lr 5/8/2005 20:32'!
isSatisfiedBy: anObject
	^ anObject perform: self selector withArguments: self arguments.! !

!MASelectorRelation methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
selector
	^ selector! !

!MASelectorRelation methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:32'!
setArguments: aCollection
	arguments := aCollection! !

!MASelectorRelation methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:32'!
setSelector: aSelector
	selector := aSelector! !

!MASelectorRelation methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:32'!
setSelector: aSelector argument: anObject
	self setSelector: (self selector , aSelector) asSymbol.
	self setArguments: (self arguments copyWith: anObject).! !

MARelation subclass: #MAComposedRelation
	instanceVariableNames: 'relations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Relation'!

MAComposedRelation subclass: #MAAllRelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Relation'!

!MAAllRelation class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MAAllRelation methodsFor: 'testing' stamp: 'lr 7/7/2005 13:30'!
isSatisfiedBy: anObject
	^ self relations allSatisfy: [ :each | each isSatisfiedBy: anObject ].! !

!MAAllRelation methodsFor: 'operators' stamp: 'lr 10/27/2005 14:12'!
& aRelation
	^ self copyWith: aRelation.! !

MAComposedRelation subclass: #MAAnyRelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Relation'!

!MAAnyRelation class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MAAnyRelation methodsFor: 'testing' stamp: 'lr 7/7/2005 13:30'!
isSatisfiedBy: anObject
	^ self relations anySatisfy: [ :each | each isSatisfiedBy: anObject ].! !

!MAAnyRelation methodsFor: 'operators' stamp: 'lr 10/27/2005 14:12'!
| aRelation
	^ self copyWith: aRelation.! !

!MAComposedRelation class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
new
	^ super new
		setRelations: Array new;
		yourself.! !

!MAComposedRelation class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
withAll: anArray
	^ self new
		setRelations: anArray;
		yourself.! !

!MAComposedRelation class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
with: aRelation
	^ self withAll: (Array with: aRelation).! !

!MAComposedRelation class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
with: aFirstRelation with: aSecondRelation
	^ self withAll: (Array with: aFirstRelation with: aSecondRelation).! !

!MAComposedRelation methodsFor: 'copying' stamp: 'lr 5/8/2005 20:30'!
copyWith: aRelation
	^ self class withAll: (self relations copyWith: aRelation).! !

!MAComposedRelation methodsFor: 'comparing' stamp: 'lr 10/3/2005 08:34'!
hash
	^ super hash bitXor: self relations hash.! !

!MAComposedRelation methodsFor: 'testing' stamp: 'lr 10/27/2005 14:26'!
isComposed
	^ true! !

!MAComposedRelation methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:30'!
relations
	^ relations! !

!MAComposedRelation methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:30'!
setRelations: aCollection
	relations := aCollection! !

!MAComposedRelation methodsFor: 'comparing' stamp: 'lr 5/8/2005 20:30'!
= anObject
	^ super = anObject
		and: [ self relations = anObject relations ].! !

MAComposedRelation subclass: #MANoneRelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Relation'!

!MANoneRelation class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MANoneRelation methodsFor: 'testing' stamp: 'lr 5/8/2005 20:31'!
isSatisfiedBy: anObject
	^ self relations noneSatisfy: [ :each | 
		each isSatisfiedBy: anObject ].! !

!MANoneRelation methodsFor: 'operators' stamp: 'lr 7/8/2005 11:01'!
!! aRelation
	^ self copyWith: aRelation.! !

!MARelation methodsFor: 'converting' stamp: 'lr 10/27/2005 14:13'!
asRelation
	^ self! !

!MARelation methodsFor: 'testing' stamp: 'lr 10/27/2005 14:26'!
isComposed
	^ false! !

!MARelation methodsFor: 'testing' stamp: 'lr 10/27/2005 13:52'!
isConstant
	^ false! !

!MARelation methodsFor: 'testing' stamp: 'lr 5/8/2005 20:31'!
isSatisfiedBy: anObject
	self subclassResponsibility.! !

!MARelation methodsFor: 'operators-unary' stamp: 'lr 5/8/2005 20:31'!
not
	^ MANoneRelation with: self.! !

!MARelation methodsFor: 'operators-binary' stamp: 'lr 7/8/2005 11:01'!
!! aRelation
	^ MANoneRelation with: self with: aRelation.! !

!MARelation methodsFor: 'operators-binary' stamp: 'lr 5/8/2005 20:31'!
& aRelation
	^ MAAllRelation with: self with: aRelation.! !

!MARelation methodsFor: 'operators-binary' stamp: 'lr 5/8/2005 20:31'!
| aRelation
	^ MAAnyRelation with: self with: aRelation.! !

Object subclass: #MAPersonModel
	instanceVariableNames: 'title firstName lastName address picture birthday phoneNumbers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Mocks'!

!MAPersonModel class methodsFor: 'accessing-description' stamp: 'lr 11/7/2005 09:13'!
descriptionAddress
	^ (MAOneToOneRelationDescription auto: 'address' label: 'Address' priority: 40)
		componentClass: MAInternalEditorComponent;
		classes: (Array with: MAAddressModel);
		yourself.! !

!MAPersonModel class methodsFor: 'accessing-description' stamp: 'lr 10/19/2005 20:26'!
descriptionAge
	^ (MANumberDescription selector: #age label: 'Age' priority: 70)
		beReadonly;
		yourself.! !

!MAPersonModel class methodsFor: 'accessing-description' stamp: 'lr 10/19/2005 20:26'!
descriptionBirthday
	^ MADateDescription auto: 'birthday' label: 'Birthday' priority: 60.! !

!MAPersonModel class methodsFor: 'accessing-description' stamp: 'lr 10/19/2005 20:25'!
descriptionFirstName
	^ (MAStringDescription auto: 'firstName' label: 'First Name' priority: 20)
		beRequired;
		yourself.! !

!MAPersonModel class methodsFor: 'accessing-description' stamp: 'lr 10/19/2005 20:26'!
descriptionLastName
	^ (MAStringDescription auto: 'lastName' label: 'Last Name' priority: 30)
		beRequired;
		yourself.! !

!MAPersonModel class methodsFor: 'accessing-description' stamp: 'lr 11/3/2005 18:07'!
descriptionPhoneNumbers
	^ (MAOneToManyRelationDescription auto: 'phoneNumbers' label: 'Phone Numbers' priority: 80)
		classes: (Array with: MAPhoneNumber);
		default: Array new;
		yourself.! !

!MAPersonModel class methodsFor: 'accessing-description' stamp: 'lr 10/28/2005 16:40'!
descriptionPicture
	^ (MAFileDescription auto: 'picture' label: 'Picture' priority: 50)
		addCondition: [ :value | value isImage ] labelled: 'Image expected';
		yourself.! !

!MAPersonModel class methodsFor: 'accessing-description' stamp: 'lr 10/19/2005 21:04'!
descriptionTitle
	^ (MASingleOptionDescription auto: 'title' label: 'Title' priority: 10)
		options: #( 'Mr.' 'Mrs.' 'Ms.' 'Miss.' );
		yourself.! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 10/19/2005 20:46'!
address
	^ address! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 10/19/2005 21:21'!
address: anObject
	address := anObject! !

!MAPersonModel methodsFor: 'accessing-calculated' stamp: 'lr 10/19/2005 00:05'!
age
	^ self birthday notNil
		ifTrue: [ Date current year - self birthday year ].! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 10/19/2005 20:43'!
birthday
	^ birthday! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 10/19/2005 21:21'!
birthday: anObject
	birthday := anObject! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 10/19/2005 20:43'!
firstName
	^ firstName! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 10/19/2005 21:21'!
firstName: anObject
	firstName := anObject! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 10/19/2005 20:43'!
lastName
	^ lastName! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 10/19/2005 21:21'!
lastName: anObject
	lastName := anObject! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 11/3/2005 18:06'!
phoneNumbers
	^ phoneNumbers! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 11/7/2005 10:52'!
phoneNumbers: anObject
	phoneNumbers := anObject! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 10/19/2005 20:43'!
picture
	^ picture! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 10/19/2005 21:21'!
picture: anObject
	picture := anObject! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 10/19/2005 20:43'!
title
	^ title! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 10/19/2005 21:21'!
title: anObject
	title := anObject! !

!MAPersonModel methodsFor: 'comparing' stamp: 'lr 10/19/2005 21:20'!
= anObject
	^ self species = anObject species
		and: [ self title = anObject title
		and: [ self firstName = anObject firstName
		and: [ self lastName = anObject lastName
		and: [ self picture = anObject picture
		and: [ self birthday = anObject birthday
		and: [ self address = anObject address ] ] ] ] ] ].! !

Object subclass: #MAPhoneNumber
	instanceVariableNames: 'kind number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Mocks'!

!MAPhoneNumber class methodsFor: 'accessing-description' stamp: 'lr 11/3/2005 18:06'!
descriptionKind
	^ MAStringDescription auto: 'kind' label: 'Kind' priority: 10.! !

!MAPhoneNumber class methodsFor: 'accessing-description' stamp: 'lr 11/3/2005 18:05'!
descriptionNumber
	^ MAStringDescription auto: 'number' label: 'Number' priority: 20.! !

!MAPhoneNumber methodsFor: 'accessing' stamp: 'lr 11/3/2005 18:06'!
kind
	^ kind! !

!MAPhoneNumber methodsFor: 'accessing' stamp: 'lr 11/3/2005 18:06'!
kind: anObject
	kind := anObject! !

!MAPhoneNumber methodsFor: 'accessing' stamp: 'lr 11/3/2005 18:06'!
number
	^ number! !

!MAPhoneNumber methodsFor: 'accessing' stamp: 'lr 11/3/2005 18:06'!
number: anObject
	number := anObject! !

Object subclass: #MAScaffolder
	instanceVariableNames: 'description values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Models'!

!MAScaffolder class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:34'!
description: aDescription
	^ self new
		description: aDescription;
		yourself.! !

!MAScaffolder methodsFor: 'accessing-configuration' stamp: 'lr 8/11/2005 13:13'!
defaultDescription
	^ MAContainer new.! !

!MAScaffolder methodsFor: 'accessing-configuration' stamp: 'lr 8/11/2005 13:13'!
defaultDictionary
	^ Dictionary new.! !

!MAScaffolder methodsFor: 'accessing' stamp: 'lr 8/11/2005 13:11'!
description
	^ description! !

!MAScaffolder methodsFor: 'accessing' stamp: 'lr 8/11/2005 13:12'!
description: aDescription
	description := aDescription! !

!MAScaffolder methodsFor: 'initialization' stamp: 'lr 8/11/2005 13:19'!
initialize
	super initialize.
	self description: self defaultDescription.
	self values: self defaultDictionary.! !

!MAScaffolder methodsFor: 'model' stamp: 'lr 10/10/2005 21:24'!
readUsing: aDescription
	^ self values at: aDescription ifAbsent: [ nil ].! !

!MAScaffolder methodsFor: 'accessing' stamp: 'lr 8/11/2005 13:18'!
values
	^ values! !

!MAScaffolder methodsFor: 'accessing' stamp: 'lr 8/11/2005 13:18'!
values: aDictionary
	values := aDictionary! !

!MAScaffolder methodsFor: 'model' stamp: 'lr 9/21/2005 07:31'!
write: anObject using: aDescription
	self values at: aDescription put: anObject.! !

Object subclass: #MATableModel
	instanceVariableNames: 'rowCount columnCount contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Models'!

!MATableModel class methodsFor: 'instance-creation' stamp: 'lr 10/3/2005 09:29'!
rows: aRowCount columns: aColumnCount
	^ self rows: aRowCount columns: aColumnCount contents: (Array new: aRowCount * aColumnCount).! !

!MATableModel class methodsFor: 'instance-creation' stamp: 'lr 10/3/2005 09:31'!
rows: aRowCount columns: aColumnCount contents: anArray
	^ self new 
		setRowCount: aRowCount;
		setColumnCount: aColumnCount;
		setContents: anArray;
		yourself.! !

!MATableModel methodsFor: 'accessing' stamp: 'lr 10/6/2005 19:29'!
at: aRowIndex at: aColumnIndex
	self checkAt: aRowIndex at: aColumnIndex.
	^ self uncheckedAt: aRowIndex at: aColumnIndex.! !

!MATableModel methodsFor: 'accessing' stamp: 'lr 10/6/2005 20:26'!
at: aRowIndex at: aColumnIndex put: aValue
	self checkAt: aRowIndex at: aColumnIndex.
	^ self uncheckedAt: aRowIndex at: aColumnIndex put: aValue.! !

!MATableModel methodsFor: 'private' stamp: 'lr 10/14/2005 09:57'!
checkAt: aRowIndex at: aColumnIndex
	(aRowIndex between: 1 and: self rowCount)
		ifFalse: [ self error: 'Row subscript out of range.' ].
	(aColumnIndex between: 1 and: self columnCount)
		ifFalse: [ self error: 'Column subscript out of range.' ].! !

!MATableModel methodsFor: 'enumeration' stamp: 'lr 10/14/2005 09:57'!
collect: aBlock
	^ self copyEmpty in: [ :table |
		self do: [ :row :col :val | 
			table 
				at: row at: col 
				put: (aBlock value: row value: col value: val) ].
		table ].! !

!MATableModel methodsFor: 'accessing' stamp: 'lr 10/3/2005 09:21'!
columnCount
	^ columnCount! !

!MATableModel methodsFor: 'accessing' stamp: 'lr 10/3/2005 09:26'!
contents
	^ contents! !

!MATableModel methodsFor: 'copying' stamp: 'lr 10/3/2005 11:18'!
copyEmpty
	^ self class rows: self rowCount columns: self columnCount.! !

!MATableModel methodsFor: 'copying' stamp: 'lr 10/6/2005 19:24'!
copyRows: aRowCount columns: aColumnCount
	| table |
	table := self class rows: aRowCount columns: aColumnCount.
	1 to: (self rowCount min: aRowCount) do: [ :row |
		1 to: (self columnCount min: aColumnCount) do: [ :col |
			table 
				uncheckedAt: row at: col 
				put: (self uncheckedAt: row at: col) ] ].
	^ table.! !

!MATableModel methodsFor: 'enumeration' stamp: 'lr 10/6/2005 19:24'!
do: aBlock
	1 to: self rowCount do: [ :row |
		1 to: self columnCount do: [ :col |
			aBlock 
				value: row value: col
				value: (self uncheckedAt: row at: col) ] ].! !

!MATableModel methodsFor: 'comparing' stamp: 'lr 10/3/2005 09:24'!
hash
	^ self contents hash.! !

!MATableModel methodsFor: 'private' stamp: 'lr 10/6/2005 19:15'!
indexAt: aRowIndex at: aColumnIndex
	^ aRowIndex - 1 * self columnCount + aColumnIndex.! !

!MATableModel methodsFor: 'private' stamp: 'lr 10/3/2005 09:35'!
pointAt: anIndex
	^ Point x: (anIndex - 1 // self columnCount + 1) y: (anIndex - 1 \\ self columnCount + 1).! !

!MATableModel methodsFor: 'copying' stamp: 'lr 10/3/2005 09:25'!
postCopy
	super postCopy.
	self setContents: self contents copy.! !

!MATableModel methodsFor: 'operations' stamp: 'lr 10/3/2005 09:49'!
reshapeRows: aRowCount columns: aColumnCount
	self setContents: (self copyRows: aRowCount columns: aColumnCount) contents.
	self setRowCount: aRowCount; setColumnCount: aColumnCount.! !

!MATableModel methodsFor: 'accessing' stamp: 'lr 10/3/2005 09:21'!
rowCount
	^ rowCount! !

!MATableModel methodsFor: 'initialization' stamp: 'lr 10/3/2005 09:27'!
setColumnCount: anInteger
	columnCount := anInteger! !

!MATableModel methodsFor: 'initialization' stamp: 'lr 10/3/2005 09:26'!
setContents: anArray
	contents := anArray! !

!MATableModel methodsFor: 'initialization' stamp: 'lr 10/3/2005 09:26'!
setRowCount: anInteger
	rowCount := anInteger! !

!MATableModel methodsFor: 'accessing' stamp: 'lr 10/6/2005 19:23'!
uncheckedAt: aRowIndex at: aColumnIndex
	^ self contents at: (self indexAt: aRowIndex at: aColumnIndex).! !

!MATableModel methodsFor: 'accessing' stamp: 'lr 10/6/2005 19:30'!
uncheckedAt: aRowIndex at: aColumnIndex put: aValue
	^ self contents at: (self indexAt: aRowIndex at: aColumnIndex) put: aValue.! !

!MATableModel methodsFor: 'comparing' stamp: 'lr 10/3/2005 09:24'!
= aTable
	^ self species = aTable species
		and: [ self rowCount = aTable rowCount ]
		and: [ self columnCount = aTable columnCount ]
		and: [ self contents = aTable contents ].! !

Object subclass: #MAVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Visitor'!

!MAVisitor commentStamp: 'lr 9/12/2005 12:14' prior: 0!
I am a visitor responsible to visit Magritte descriptions. I am an abstract calss providing a default implementation for concrete visitors. The protocol I am implementing reflects the hierarchy of MADescription with its subclasses so that visiting a specific class automatically calls less specific implementations in case the specific implementation has been left out. This code was automatically using #buildVisitorHierarchyForClass:selector:classified: on my class-side.!

MAVisitor subclass: #MAStreamingVisitor
	instanceVariableNames: 'stream object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Visitor'!

MAStreamingVisitor subclass: #MAReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Visitor'!

MAReader subclass: #MABinaryReader
	instanceVariableNames: 'version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Visitor'!

!MABinaryReader class methodsFor: 'instance-creation' stamp: 'lr 10/13/2005 20:10'!
read: aStream
	^ self new read: aStream.! !

!MABinaryReader methodsFor: 'private' stamp: 'lr 10/24/2005 10:08'!
readNext
	self version: self stream next.
	self version isInteger
		ifFalse: [ self error: 'Invalid File Format.' ].
	self stream next in: [ :description |
		description isDescription
			ifFalse: [ self error: 'Invalid File Description.' ].
		description class version <= self version 
			ifFalse: [ self error: 'Invalid File Version.' ].
		self visit: description ].
	^ self object.! !

!MABinaryReader methodsFor: 'visiting' stamp: 'lr 10/13/2005 20:12'!
read: aStream
	^ self stream: (MACompatibility referenceStream: aStream); readNext; object.! !

!MABinaryReader methodsFor: 'accessing' stamp: 'lr 10/13/2005 16:43'!
version
	^ version! !

!MABinaryReader methodsFor: 'accessing' stamp: 'lr 10/13/2005 16:43'!
version: aVersion
	version := aVersion! !

!MABinaryReader methodsFor: 'visiting-description' stamp: 'lr 10/13/2005 20:28'!
visitContainer: aDescription
	self object: self stream next new.
	aDescription do: [ :each | self readNext ].! !

!MABinaryReader methodsFor: 'visiting-description' stamp: 'lr 10/13/2005 20:29'!
visitElementDescription: aDescription
	self object write: self stream next using: aDescription.! !

!MABinaryReader methodsFor: 'visiting-description' stamp: 'lr 10/24/2005 10:09'!
visitOneToOneRelationDescription: aDescription
	| parent |
	parent := self object.
	[ parent write: self readNext using: aDescription ]
		ensure: [ self object: parent ].! !

!MAReader class methodsFor: 'instance creation' stamp: 'lr 10/13/2005 18:50'!
read: aStream description: aDescription
	^ self new read: aStream description: aDescription.! !

!MAReader methodsFor: 'private' stamp: 'lr 10/13/2005 16:55'!
error: aString
	MAReadError signal: aString.! !

!MAReader methodsFor: 'visiting' stamp: 'lr 10/13/2005 18:51'!
read: aStream description: aDescription
	^ self stream: aStream; visit: aDescription; object.! !

MAReader subclass: #MAStringReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Visitor'!

!MAStringReader methodsFor: 'visiting' stamp: 'lr 10/13/2005 18:53'!
read: aStream description: aDescription
	^ aStream atEnd
		ifFalse: [ super read: aStream description: aDescription ].! !

!MAStringReader methodsFor: 'visiting-description' stamp: 'lr 10/12/2005 13:43'!
visitBooleanDescription: aDescription
	(aDescription trueStrings includes: self contents)
		ifTrue: [ self object: true ].
	(aDescription falseStrings includes: self contents)
		ifTrue: [ self object: false ].! !

!MAStringReader methodsFor: 'visiting-description' stamp: 'lr 10/31/2005 10:38'!
visitClassDescription: aDescription
	self shouldNotImplement.! !

!MAStringReader methodsFor: 'visiting-description' stamp: 'lr 10/12/2005 13:55'!
visitColorDescription: aDescription
	self object: (aDescription kind fromString: self contents).! !

!MAStringReader methodsFor: 'visiting-description' stamp: 'lr 10/28/2005 16:09'!
visitContainer: anObject
	self shouldNotImplement.! !

!MAStringReader methodsFor: 'visiting-description' stamp: 'lr 10/12/2005 13:46'!
visitElementDescription: aDescription
	self object: (aDescription kind readFrom: self stream).! !

!MAStringReader methodsFor: 'visiting-description' stamp: 'lr 10/6/2005 19:35'!
visitFileDescription: aDescription
	self shouldNotImplement.! !

!MAStringReader methodsFor: 'visiting-description' stamp: 'lr 10/30/2005 22:22'!
visitMultipleOptionDescription: aDescription
	self object: (Array streamContents: [ :output |
		[ self stream atEnd ] whileFalse: [
			output nextPut: (aDescription reference
				fromString: (self stream upToAll: ', ')) ] ]).! !

!MAStringReader methodsFor: 'visiting-description' stamp: 'lr 10/28/2005 16:08'!
visitRelationDescription: aDescription
	self shouldNotImplement.! !

!MAStringReader methodsFor: 'visiting-description' stamp: 'lr 10/12/2005 13:48'!
visitSingleOptionDescription: aDescription
	self visit: aDescription reference.! !

!MAStringReader methodsFor: 'visiting-description' stamp: 'lr 10/12/2005 13:48'!
visitStringDescription: aDescription
	self object: self contents.! !

!MAStringReader methodsFor: 'visiting-description' stamp: 'lr 10/12/2005 13:48'!
visitSymbolDescription: aDescription
	self object: self contents asSymbol.! !

!MAStringReader methodsFor: 'visiting-description' stamp: 'lr 10/28/2005 16:14'!
visitTableDescription: aDescription
	self shouldNotImplement.! !

!MAStringReader methodsFor: 'visiting-description' stamp: 'lr 10/12/2005 13:55'!
visitTokenDescription: aDescription
	self object: (aDescription kind streamContents: [ :output |
		[ self stream atEnd ] whileFalse: [
			output nextPut: (aDescription reference
				fromString: (self stream upTo: $ )) ] ]).! !

!MAStreamingVisitor methodsFor: 'streaming' stamp: 'lr 10/10/2005 09:14'!
contents
	^ self stream contents.! !

!MAStreamingVisitor methodsFor: 'accessing' stamp: 'lr 10/13/2005 16:54'!
object
	^ object! !

!MAStreamingVisitor methodsFor: 'accessing' stamp: 'lr 10/13/2005 16:54'!
object: anObject
	object := anObject! !

!MAStreamingVisitor methodsFor: 'private' stamp: 'lr 10/13/2005 16:53'!
object: anObject during: aBlock
	| previous |
	previous := self object. self object: anObject.
	aBlock ensure: [ self object: previous ].! !

!MAStreamingVisitor methodsFor: 'accessing' stamp: 'lr 10/7/2005 08:22'!
stream
	^ stream! !

!MAStreamingVisitor methodsFor: 'accessing' stamp: 'lr 10/7/2005 08:23'!
stream: aStream
	stream := aStream! !

MAStreamingVisitor subclass: #MAWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Visitor'!

MAWriter subclass: #MABinaryWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Visitor'!

!MABinaryWriter methodsFor: 'private' stamp: 'lr 10/13/2005 18:41'!
defaultWriteStream
	^ MACompatibility referenceStream: ByteArray new writeStream.! !

!MABinaryWriter methodsFor: 'visiting-description' stamp: 'lr 10/25/2005 23:44'!
visitContainer: aDescription
	super visitContainer: aDescription.
	self stream nextPut: self object class.
	aDescription do: [ :each | 
		each isPersistent ifTrue: [ 
			self 
				object: (self object readUsing: each)
				during: [ self visit: each ] ] ].! !

!MABinaryWriter methodsFor: 'visiting-description' stamp: 'lr 10/13/2005 20:01'!
visitDescription: aDescription
	self stream nextPut: aDescription class version; nextPut: aDescription.! !

!MABinaryWriter methodsFor: 'visiting-description' stamp: 'lr 10/20/2005 11:22'!
visitElementDescription: aDescription
	super visitElementDescription: aDescription.
	self stream nextPut: self object.! !

!MABinaryWriter methodsFor: 'visiting-description' stamp: 'lr 10/24/2005 10:00'!
visitOneToOneRelationDescription: aDescription
	self visitDescription: aDescription.
	self visit: aDescription reference.! !

MAWriter subclass: #MAStringWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Visitor'!

!MAStringWriter methodsFor: 'private' stamp: 'lr 10/12/2005 13:31'!
defaultWriteStream
	^ String new writeStream.! !

!MAStringWriter methodsFor: 'visiting-description' stamp: 'lr 10/10/2005 09:16'!
visitBooleanDescription: aDescription
	self stream nextPutAll: (self object
		ifTrue: [ aDescription trueStrings first ]
		ifFalse: [ aDescription falseStrings first ]).! !

!MAStringWriter methodsFor: 'visiting-description' stamp: 'lr 10/29/2005 22:07'!
visitClassDescription: aDescription
	self stream nextPutAll: self object label.! !

!MAStringWriter methodsFor: 'visiting-description' stamp: 'lr 10/12/2005 13:53'!
visitColorDescription: aDescription
	stream nextPut: $#.
	stream nextPutAll: ((255 * self object red) asInteger 
		printPaddedWith: $0 to: 2 base: 16).
	stream nextPutAll: ((255 * self object green) asInteger
		printPaddedWith: $0 to: 2 base: 16).
	stream nextPutAll: ((255 * self object blue) asInteger
		printPaddedWith: $0 to: 2 base: 16).! !

!MAStringWriter methodsFor: 'visiting-description' stamp: 'lr 10/25/2005 23:44'!
visitContainer: aDescription
	aDescription
		do: [ :each |
			each hasLabel
				ifTrue: [ stream nextPutAll: each label; nextPutAll: ': ' ].
			each stringWriter 
				write: (self object readUsing: each)
				description: each to: stream ]
		separatedBy: [ stream nextPutAll: '; ' ].! !

!MAStringWriter methodsFor: 'visiting-description' stamp: 'lr 10/18/2005 23:40'!
visitElementDescription: aDescription
	self stream nextPutAll: self object asString.! !

!MAStringWriter methodsFor: 'visiting-description' stamp: 'lr 10/10/2005 09:16'!
visitFileDescription: aDescription
	self stream nextPutAll: self object filename.! !

!MAStringWriter methodsFor: 'visiting-description' stamp: 'lr 10/28/2005 16:02'!
visitMultipleOptionDescription: aDescription
	self object
		do: [ :each | self object: each during: [ self visit: aDescription reference ] ]
		separatedBy: [ self stream nextPutAll: ', ' ].! !

!MAStringWriter methodsFor: 'visiting-description' stamp: 'lr 10/28/2005 16:03'!
visitOneToManyRelationDescription: aDescription
	self object
		do: [ :each | self object: each during: [ self visit: each description ] ]
		separatedBy: [ self stream nextPutAll: ', ' ].! !

!MAStringWriter methodsFor: 'visiting-description' stamp: 'lr 10/27/2005 17:39'!
visitOneToOneRelationDescription: aDescription
	self visit: self object description.! !

!MAStringWriter methodsFor: 'visiting-description' stamp: 'lr 10/10/2005 09:11'!
visitSingleOptionDescription: aDescription
	self visit: aDescription reference.! !

!MAStringWriter methodsFor: 'visiting-description' stamp: 'lr 10/10/2005 09:29'!
visitStringDescription: aDescription
	self stream nextPutAll: self object.! !

!MAStringWriter methodsFor: 'visiting-description' stamp: 'lr 10/10/2005 09:12'!
visitTimeDescription: aDescription
	self object print24: true showSeconds: true on: self stream.! !

!MAStringWriter methodsFor: 'visiting-description' stamp: 'lr 10/10/2005 09:13'!
visitTimeStampDescription: aDescription
	self stream print: self object asDate; space.
	self stream print: self object asTime.! !

!MAStringWriter methodsFor: 'visiting-description' stamp: 'lr 10/10/2005 09:19'!
visitTokenDescription: aDescription
	self object
		do: [ :each | self object: each during: [ self visit: aDescription reference ] ]
		separatedBy: [ self stream nextPutAll: ' '  ].! !

!MAStringWriter methodsFor: 'visiting' stamp: 'lr 10/13/2005 16:57'!
write: anObject description: aDescription to: aStream
	anObject isNil ifTrue: [ ^ aDescription undefined ].
	^ super write: anObject description: aDescription to: aStream.! !

!MAWriter class methodsFor: 'instance creation' stamp: 'lr 10/13/2005 20:52'!
write: anObject
	^ self new write: anObject.! !

!MAWriter class methodsFor: 'instance creation' stamp: 'lr 10/13/2005 16:56'!
write: anObject description: aDescription
	^ self new write: anObject description: aDescription.! !

!MAWriter class methodsFor: 'instance creation' stamp: 'lr 10/13/2005 16:56'!
write: anObject description: aDescription to: aStream
	^ self new write: anObject description: aDescription to: aStream.! !

!MAWriter methodsFor: 'private' stamp: 'lr 10/18/2005 22:30'!
defaultWriteStream
	self subclassResponsibility.! !

!MAWriter methodsFor: 'private' stamp: 'lr 10/13/2005 16:55'!
error: aString
	MAWriteError signal: aString.! !

!MAWriter methodsFor: 'visiting' stamp: 'lr 10/13/2005 20:53'!
write: anObject
	^ self write: anObject description: anObject description.! !

!MAWriter methodsFor: 'visiting' stamp: 'lr 10/13/2005 16:58'!
write: anObject description: aDescription
	^ self write: anObject description: aDescription to: self defaultWriteStream.! !

!MAWriter methodsFor: 'visiting' stamp: 'lr 10/13/2005 16:58'!
write: anObject description: aDescription to: aStream
	^ self object: anObject; stream: aStream; visit: aDescription; contents.! !

!MAVisitor class methodsFor: 'private' stamp: 'lr 10/12/2005 13:50'!
buildVisitorHierarchyForClass: aClass selector: aBlock classified: aSelector
	" self buildVisitorHierarchyForClass: MADescription selector: [ :class | 'visit' , (class name allButFirst: 2) , ':' ] classified: #'visiting-description' "
	
	aClass withAllSubclassesDo: [ :class |
		(class category beginsWith: 'Magritte') ifTrue: [
			self
				compile: (String streamContents: [ :stream |
					stream nextPutAll: (aBlock value: class); nextPutAll: ' anObject'; cr.
					class = aClass ifFalse: [ 
						stream tab; nextPutAll: 'self '; nextPutAll: (aBlock value: class superclass); nextPutAll: ' anObject.' ] ])
				classified: aSelector.
			class
				compile: (String streamContents: [ :stream |
					stream nextPutAll: 'acceptMagritte: aVisitor'; cr.
					stream tab; nextPutAll: 'aVisitor '; nextPutAll: (aBlock value: class); nextPutAll: ' self.' ])
				classified: #visiting ] ].! !

!MAVisitor methodsFor: 'visiting' stamp: 'lr 10/19/2005 19:53'!
visitAll: aCollection
	aCollection do: [ :each | self visit: each ].! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 10/29/2005 20:48'!
visitBooleanDescription: anObject
	self visitElementDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 10/29/2005 20:48'!
visitClassDescription: anObject
	self visitElementDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 10/29/2005 20:48'!
visitColorDescription: anObject
	self visitElementDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 10/29/2005 20:48'!
visitContainer: anObject
	self visitDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 10/29/2005 20:48'!
visitDateDescription: anObject
	self visitMagnitudeDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 10/29/2005 20:48'!
visitDescription: anObject
! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 10/29/2005 20:48'!
visitDurationDescription: anObject
	self visitMagnitudeDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 10/29/2005 20:48'!
visitElementDescription: anObject
	self visitDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 10/29/2005 20:48'!
visitFileDescription: anObject
	self visitElementDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 10/29/2005 20:48'!
visitMagnitudeDescription: anObject
	self visitElementDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 10/29/2005 20:48'!
visitMultipleOptionDescription: anObject
	self visitOptionDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 10/29/2005 20:48'!
visitNumberDescription: anObject
	self visitMagnitudeDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 10/29/2005 20:48'!
visitOneToManyRelationDescription: anObject
	self visitRelationDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 10/29/2005 20:48'!
visitOneToOneRelationDescription: anObject
	self visitRelationDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 10/29/2005 20:48'!
visitOptionDescription: anObject
	self visitReferenceDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 10/29/2005 20:48'!
visitPasswordDescription: anObject
	self visitStringDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 10/29/2005 20:48'!
visitPriorityContainer: anObject
	self visitContainer: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 10/29/2005 20:48'!
visitReferenceDescription: anObject
	self visitElementDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 10/29/2005 20:48'!
visitRelationDescription: anObject
	self visitReferenceDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 10/29/2005 20:48'!
visitReportContainer: anObject
	self visitContainer: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 10/29/2005 20:48'!
visitSingleOptionDescription: anObject
	self visitOptionDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 10/29/2005 20:48'!
visitStringDescription: anObject
	self visitElementDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 10/29/2005 20:48'!
visitSymbolDescription: anObject
	self visitStringDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 10/29/2005 20:48'!
visitTableDescription: anObject
	self visitReferenceDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 9/22/2005 23:00'!
visitTableReference: anObject
	^ self visitReferenceDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 10/29/2005 20:48'!
visitTextDescription: anObject
	self visitStringDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 10/29/2005 20:48'!
visitTimeDescription: anObject
	self visitMagnitudeDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 10/29/2005 20:48'!
visitTimeStampDescription: anObject
	self visitMagnitudeDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 10/29/2005 20:48'!
visitTokenDescription: anObject
	self visitReferenceDescription: anObject.! !

!MAVisitor methodsFor: 'visiting' stamp: 'lr 10/12/2005 13:52'!
visit: anObject
	anObject acceptMagritte: self.! !

!Object class methodsFor: '*Magritte-Model-accessing' stamp: 'lr 5/8/2005 20:29'!
description
	^ MACachedBuilder default build: self.! !

!Object methodsFor: '*Magritte-Model-accessing' stamp: 'lr 5/8/2005 20:29'!
description
	"Return the description of the reciever. Subclasses might override this message to return instance-based descriptions."
	
	^ self class description.! !

!Object methodsFor: '*Magritte-Model-testing' stamp: 'lr 5/8/2005 20:29'!
isDescription
	^ false! !

!Object methodsFor: '*Magritte-Model-accessing' stamp: 'lr 9/22/2005 00:30'!
mementoClass
	^ MACheckedMemento! !

!Object methodsFor: '*Magritte-Model-model' stamp: 'lr 5/8/2005 20:29'!
readUsing: aDescription
	"Dispatch the read-access to the receiver using the accessor of aDescription."

	^ aDescription accessor read: self.! !

!Object methodsFor: '*Magritte-Model-model' stamp: 'lr 5/8/2005 20:29'!
write: anObject using: aDescription
	"Dispatch the write-access to the receiver of anObject using the accessor of aDescription."

	aDescription accessor write: anObject to: self.! !

!SequenceableCollection methodsFor: '*Magritte-Model-moving' stamp: 'lr 10/17/2005 08:40'!
moveDown: anObject	
	| first second |
	first := self indexOf: anObject ifAbsent: [ ^ 0 ].
	second := first < self size ifTrue: [ first + 1 ] ifFalse: [ ^ first ].
	self swap: first with: second.
	^ second.! !

!SequenceableCollection methodsFor: '*Magritte-Model-moving' stamp: 'lr 10/17/2005 08:43'!
moveUp: anObject	
	| first second |
	first := self indexOf: anObject ifAbsent: [ ^ 0 ].
	second := first > 1 ifTrue: [ first - 1 ] ifFalse: [ ^ first ].
	self swap: first with: second.
	^ second.! !

!Class methodsFor: '*Magritte-Model-configuration' stamp: 'lr 11/1/2005 22:09'!
defaultContainer
	"Return the default description container."
	
	^ MAPriorityContainer new
		label: self label;
		yourself.! !

!Class methodsFor: '*Magritte-Model-accessing' stamp: 'lr 10/30/2005 12:55'!
label
	"Answer a human-readable name of the receiving class. This implementation tries to be smart and return a nice label, unfortunately for a lot of classes this doesn't work well so subclasses might want to override this method and return soemthing more meaningfull to end-users."

	| start input |
	start := self name findFirst: [ :each | each isLowercase ].
	input := (self name copyFrom: (1 max: start - 1) to: self name size) 
		readStream.
	^ String streamContents: [ :stream |
		[ input atEnd ] whileFalse: [
			stream nextPut: input next.
			(input atEnd or: [ input peek isLowercase ])
				ifFalse: [ stream nextPut: Character space ] ] ].! !

ProtoObject subclass: #MAProxyObject
	instanceVariableNames: 'realSubject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Utility'!

MAProxyObject subclass: #MADynamicObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Utility'!

!MADynamicObject methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
realSubject
	^ super realSubject value.! !

!MAProxyObject class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
on: anObject
	^ self basicNew realSubject: anObject.! !

!MAProxyObject methodsFor: 'private' stamp: 'lr 5/8/2005 20:31'!
doesNotUnderstand: aMessage
	^ self realSubject
		perform: aMessage selector
		withArguments: aMessage arguments.! !

!MAProxyObject methodsFor: 'testing' stamp: 'lr 5/8/2005 20:31'!
isMorph
	^ false! !

!MAProxyObject methodsFor: 'testing' stamp: 'lr 5/8/2005 20:31'!
isNil
	^ self realSubject isNil.! !

!MAProxyObject methodsFor: 'printing' stamp: 'lr 5/8/2005 20:31'!
printOn: aStream
	aStream nextPut: $[; print: self realSubject; nextPut: $].! !

!MAProxyObject methodsFor: 'printing' stamp: 'lr 5/8/2005 20:31'!
printString
	^ String streamContents: [ :stream | self printOn: stream ].! !

!MAProxyObject methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
realSubject
	^ realSubject! !

!MAProxyObject methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
realSubject: anObject
	realSubject := anObject! !

SmaCCParser subclass: #MARelationParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Model-Relation'!

!MARelationParser class methodsFor: 'generated-comments' stamp: 'lr 8/13/2005 13:02'!
parserDefinitionComment

	"Start
	: { nil }
	| Expression { #liftFirstValue: } 
	;


# E X P R E S S I O N S

Expression
	: OrExpression { #liftFirstValue: } 
	;

OrExpression
	: OrExpression 'expr1' ""OR"" AndExpression 'expr2' { MAAnyRelation with: expr1 with: expr2 }
	| AndExpression { #liftFirstValue: } 
	;

AndExpression
	: AndExpression 'expr1' ""AND"" NotExpression 'expr2' { MAAllRelation with: expr1 with: expr2 }
	| AndExpression 'expr1' NotExpression 'expr2' { MAAllRelation with: expr1 with: expr2 }
	| NotExpression { #liftFirstValue: } 
	;

NotExpression
	: ""NOT"" NotExpression 'expr' { MANoneRelation with: expr }
	| ""-"" NotExpression 'expr' { MANoneRelation with: expr }
	| ""("" Expression 'expr' "")"" { expr }
	| Relation { #liftFirstValue: } 
	; 


# R E L A T I O N S

Relation
	: Accessor 'accessor' UnaryMessage 'message' { self customize: message with: accessor } 
	| Accessor 'accessor' BinaryMessage 'message' { self customize: message with: accessor } 
	| Accessor 'accessor' KeywordMessage 'message' { self customize: message with: accessor }
	| LiteralValue 'literal' { MAQueryRelation selector: #matches: with: literal }
	;
	
Accessor
	: UnarySelector 'unary' { MASelectorAccessor selector: unary }
	;
	
UnaryMessage
	: UnarySelector 'unary' { MAAccessorRelation selector: unary }
	;
	
BinaryMessage
	: BinarySelector 'binary' LiteralValue 'literal' { MAAccessorRelation selector: binary with: literal }
	;
	
KeywordMessage
	: KeywordSelector 'keyword' LiteralValue 'literal' { MAAccessorRelation selector: keyword with: literal }
	| KeywordMessage 'message' KeywordSelector 'keyword' LiteralValue 'literal' { message setSelector: keyword argument: literal }
	;


# V A L U E S
	
UnarySelector
	: <unary> 'unary' { unary value asSymbol }
	;
	
BinarySelector
	: <binary> 'binary' { binary value asSymbol }
	;
	
KeywordSelector
	: <keyword> 'keyword' { keyword value asSymbol }
	;

LiteralValue
	: ""true"" { true }
	| ""false"" { false }
	| ""nil"" { nil }
	| <number> 'number' { number value asNumber }
	| <string> 'string' { string value copyFrom: 2 to: string value size - 1 }
	;"! !

!MARelationParser class methodsFor: 'generated-accessing' stamp: 'lr 8/13/2005 13:02'!
scannerClass
	^MARelationScanner! !

!MARelationParser class methodsFor: 'generated-starting states' stamp: 'lr 8/13/2005 13:02'!
startingStateForStart
	^1! !

!MARelationParser methodsFor: 'building' stamp: 'lr 5/8/2005 20:31'!
customize: aRelation with: anAccessor
	(MABlockToRelation includesSelector: aRelation selector) 
		ifFalse: [ self error: aRelation selector , ' is an unknown selector.' ].
	^ aRelation setAccessor: anAccessor.! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForAccessor1: nodes 
	^MASelectorAccessor selector: (nodes at: 1)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForAndExpression1: nodes 
	^MAAllRelation with: (nodes at: 1) with: (nodes at: 3)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForAndExpression2: nodes 
	^MAAllRelation with: (nodes at: 1) with: (nodes at: 2)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForBinaryMessage1: nodes 
	^MAAccessorRelation selector: (nodes at: 1) with: (nodes at: 2)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForBinarySelector1: nodes 
	^(nodes at: 1) value asSymbol! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForKeywordMessage1: nodes 
	^MAAccessorRelation selector: (nodes at: 1) with: (nodes at: 2)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForKeywordMessage2: nodes 
	^(nodes at: 1) setSelector: (nodes at: 2) argument: (nodes at: 3)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForKeywordSelector1: nodes 
	^(nodes at: 1) value asSymbol! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForLiteralValue1: nodes 
	^true! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForLiteralValue2: nodes 
	^false! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForLiteralValue3: nodes 
	^nil! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForLiteralValue4: nodes 
	^(nodes at: 1) value asNumber! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForLiteralValue5: nodes 
	^(nodes at: 1) value copyFrom: 2 to: (nodes at: 1) value size - 1! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForNotExpression1: nodes 
	^MANoneRelation with: (nodes at: 2)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForNotExpression2: nodes 
	^MANoneRelation with: (nodes at: 2)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForNotExpression3: nodes 
	^nodes at: 2! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForOrExpression1: nodes 
	^MAAnyRelation with: (nodes at: 1) with: (nodes at: 3)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForRelation1: nodes 
	^self customize: (nodes at: 2) with: (nodes at: 1)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForRelation2: nodes 
	^self customize: (nodes at: 2) with: (nodes at: 1)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForRelation3: nodes 
	^self customize: (nodes at: 2) with: (nodes at: 1)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForRelation4: nodes 
	^MAQueryRelation selector: #matches: with: (nodes at: 1)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForStart1: nodes 
	^nil! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForUnaryMessage1: nodes 
	^MAAccessorRelation selector: (nodes at: 1)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForUnarySelector1: nodes 
	^(nodes at: 1) value asSymbol! !

!MARelationParser methodsFor: 'generated-tables' stamp: 'lr 8/13/2005 13:02'!
reduceTable
	^#(
#(17 2 #reduceActionForRelation1:)
#(17 2 #reduceActionForRelation2:)
#(17 2 #reduceActionForRelation3:)
#(17 1 #reduceActionForRelation4:)
#(18 1 #reduceActionForUnaryMessage1:)
#(19 2 #reduceActionForBinaryMessage1:)
#(20 2 #reduceActionForKeywordMessage1:)
#(20 3 #reduceActionForKeywordMessage2:)
#(21 1 #reduceActionForLiteralValue1:)
#(21 1 #reduceActionForLiteralValue2:)
#(21 1 #reduceActionForLiteralValue3:)
#(21 1 #reduceActionForLiteralValue4:)
#(21 1 #reduceActionForLiteralValue5:)
#(22 1 #reduceActionForUnarySelector1:)
#(23 1 #reduceActionForBinarySelector1:)
#(24 1 #reduceActionForKeywordSelector1:)
#(25 2 #reduceActionForNotExpression1:)
#(25 2 #reduceActionForNotExpression2:)
#(25 3 #reduceActionForNotExpression3:)
#(25 1 #liftFirstValue:)
#(26 3 #reduceActionForAndExpression1:)
#(26 2 #reduceActionForAndExpression2:)
#(26 1 #liftFirstValue:)
#(27 3 #reduceActionForOrExpression1:)
#(27 1 #liftFirstValue:)
#(28 1 #reduceFor:)
#(29 0 #reduceActionForStart1:)
#(29 1 #liftFirstValue:)
#(32 1 #liftFirstValue:)
#(33 1 #reduceActionForAccessor1:)
)! !

!MARelationParser methodsFor: 'generated-tables' stamp: 'lr 8/13/2005 13:02'!
transitionTable
	^#(
#(3 9 1 13 2 17 3 21 6 25 7 29 8 33 10 37 11 41 12 45 17 49 21 53 22 57 25 61 26 65 27 69 29 110 30 73 32 77 33)
#(3 9 1 13 2 17 3 21 6 25 7 29 8 33 10 37 11 41 12 45 17 49 21 53 22 81 25 77 33)
#(2 46 1 2 3 4 5 6 7 8 9 10 11 12 13 30)
#(3 9 1 13 2 17 3 21 6 25 7 29 8 33 10 37 11 41 12 45 17 49 21 53 22 85 25 77 33)
#(2 42 1 2 3 4 5 6 7 8 9 10 11 12 13 30)
#(2 38 1 2 3 4 5 6 7 8 9 10 11 12 13 30)
#(3 9 1 13 2 17 3 21 6 25 7 29 8 33 10 37 11 41 12 45 17 49 21 53 22 57 25 61 26 65 27 89 32 77 33)
#(2 58 1 2 3 4 5 6 7 8 9 10 11 12 13 14 30)
#(2 50 1 2 3 4 5 6 7 8 9 10 11 12 13 30)
#(2 54 1 2 3 4 5 6 7 8 9 10 11 12 13 30)
#(2 82 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(2 18 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(2 122 10 13 14)
#(2 94 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(3 9 1 13 2 17 3 93 4 102 5 21 6 25 7 29 8 102 9 33 10 37 11 41 12 45 17 49 21 53 22 97 25 102 30 77 33)
#(3 101 5 118 9 118 30)
#(2 0 30)
#(2 114 30)
#(3 33 10 105 13 109 14 113 18 117 19 121 20 125 22 129 23 133 24)
#(2 70 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(2 74 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(2 137 9)
#(3 9 1 13 2 17 3 21 6 25 7 29 8 33 10 37 11 41 12 45 17 49 21 53 22 141 25 77 33)
#(2 90 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(3 9 1 13 2 17 3 21 6 25 7 29 8 33 10 37 11 41 12 45 17 49 21 53 22 57 25 145 26 77 33)
#(2 66 2 6 7 11 12)
#(2 62 2 6 7 11 12)
#(2 6 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(2 10 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(3 14 1 14 2 14 3 14 4 14 5 14 6 14 7 14 8 14 9 14 10 14 11 14 12 105 13 149 24 14 30)
#(2 22 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(3 13 2 21 6 25 7 37 11 41 12 153 21)
#(3 13 2 21 6 25 7 37 11 41 12 157 21)
#(2 78 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(2 86 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(3 9 1 13 2 17 3 93 4 98 5 21 6 25 7 29 8 98 9 33 10 37 11 41 12 45 17 49 21 53 22 97 25 98 30 77 33)
#(3 13 2 21 6 25 7 37 11 41 12 161 21)
#(2 26 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(2 30 1 2 3 4 5 6 7 8 9 10 11 12 13 30)
#(2 34 1 2 3 4 5 6 7 8 9 10 11 12 13 30)
)! !

!UndefinedObject methodsFor: '*Magritte-Model-accessing' stamp: 'lr 10/29/2005 21:04'!
label
	^ 'n/a'! !

!String methodsFor: '*Magritte-Model-testing' stamp: 'lr 10/17/2005 09:01'!
matches: aString
	aString isEmpty ifTrue: [ ^ true ].
	^ (aString includesAnyOf: '*#')
		ifTrue: [ aString match: self ]
		ifFalse: [ self includesSubstring: aString caseSensitive: false ].! !

!Integer methodsFor: '*Magritte-Model-converting' stamp: 'lr 5/8/2005 20:29'!
asFileSize
	#( 'B' 'KB' 'MB' 'GB' 'TB' 'PB' 'EB' 'ZB' 'YB' )
		inject: self
		into: [ :value :each |
			value < 1024
				ifFalse: [ value // 1024 ]
				ifTrue: [ ^ value asString , ' ' , each ] ].! !

!BlockContext methodsFor: '*Magritte-Model' stamp: 'lr 10/27/2005 14:14'!
asRelation
	^ MABlockToRelation do: self.! !
MAFileModel initialize!
